Bits for cue work, still under progress...
[clinton/abcde.git] / abcde
1 #!/bin/sh
2 # Copyright (c) 1998-2001 Robert Woodcock <rcw@debian.org>
3 # Copyright (c) 2003-2004 Jesus Climent <jesus.climent@hispalinux.es>
4 # This code is hereby licensed for public consumption under either the
5 # GNU GPL v2 or greater, or Larry Wall's Artistic license - your choice.
6 #
7 # You should have received a copy of the GNU General Public License
8 # along with this program; if not, write to the Free Software
9 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
10 #
11 # Copyright for this work is to expire January 1, 2010, after which it
12 # shall be public domain.
13
14 VERSION="2.3.0"
15
16 usage ()
17 {
18 echo "This is abcde v$VERSION."
19 echo "Usage: abcde [options] [tracks]"
20 echo "Options:"
21 echo "-1 Encode the whole CD in a single file"
22 echo "-a <action1[,action2]...>"
23 echo " Actions to perform (cddb,read,normalize,encode,tag,move,playlist,clean)"
24 #echo "-A Experimental actions (retag, transcode)"
25 echo "-b Batch mode: enable album normalization and nogap encoding"
26 echo "-c <file>"
27 echo " Specify a configuration file (overrides system and user config files)"
28 echo "-C <discid#>"
29 echo " Specify discid to resume from (only needed if you no longer have the cd)"
30 echo "-d <device>"
31 echo " Specify CDROM device to grab"
32 echo "-D Debugging mode (equivalent to sh -x abcde)"
33 echo "-e Erase encoded track information from status file"
34 echo "-h This help information"
35 #echo "-i Tag files while encoding, when possible (local only) -NWY-"
36 echo "-j <#> Number of encoder processes to run at once (localhost)"
37 echo "-k Keep the wav tracks for later use"
38 echo "-l Use low disk space algorithm"
39 echo "-L Use local CDDB storage directory"
40 echo "-n No lookup. Don't query CDDB, just create and use template"
41 echo "-N Noninteractive. Never prompt for anything"
42 echo "-m Modify playlist to include CRLF endings, to comply with some players"
43 echo "-M Create a CUE file"
44 echo "-o <type1[,type2]...>"
45 echo " Output file type(s) (ogg,mp3,flac,spx,mpc). Defaults to ogg"
46 echo "-p Pad track numbers with 0's (if less than 10 tracks)"
47 echo "-P Use UNIX pipes to read+encode without wav files"
48 echo "-r <host1[,host2]...>"
49 echo " Also encode on these remote hosts"
50 echo "-R Add replaygain values to the tag info (only for ogg,flac)"
51 echo "-S <#> Set the CD speed"
52 #echo "-t File types to preprocess (wav)"
53 #echo "-T Set postprocessing options"
54 echo "-t <#> Start the track numbering at a given number"
55 echo "-T <#> Same as -t but modifies tag numbering"
56 echo "-v Show version number and exit"
57 echo "-V Be a bit more verbose about what is happening behind the scenes"
58 echo "-x Eject CD after all tracks are read"
59 echo "-w <comment>"
60 echo " Add a comment to the CD tracks"
61 echo "-W <#> Contatenate CDs: -T #01 -w \"CD #\""
62 echo ""
63 echo "Tracks is a space-delimited list of tracks to grab."
64 echo "Ranges specified with hyphens are allowed."
65 #echo "Double hyphens are used to concatenate tracks"
66 }
67
68 # Funtions to replace the need of seq, which is too distribution dependant.
69 f_seq_row ()
70 {
71 i=$1
72 while [ $i -ne `expr $2 + 1` ]
73 do
74 echo $i
75 i=`expr $i + 1`
76 done
77 }
78
79 f_seq_line ()
80 {
81 i=$1
82 while [ $i -ne `expr $2 + 1` ]
83 do
84 printf $i" "
85 i=`expr $i + 1`
86 done
87 echo
88 }
89
90 # Functions to replace the need of awk {print $1} and {print $NF}
91 get_first()
92 {
93 if [ X"$1" = "X" ]; then
94 for first in `cat`; do
95 break
96 done
97 else
98 first=$1
99 fi
100 echo $first
101 }
102
103 get_last()
104 {
105 if [ X"$1" = "X" ]; then
106 for stdin in `cat`; do
107 last=$stdin
108 done
109 else
110 for last in $@ ; do :; done
111 fi
112 echo $last
113 }
114
115 # checkstatus [blurb]
116 # Returns "0" if the blurb was found, returns 1 if it wasn't
117 # Puts the blurb content, if available, on stdout.
118 # Otherwise, returns "".
119 checkstatus ()
120 {
121 # Take the last line in the status file if there's multiple matches
122 PATTERN="^$1(=.*)?$"
123 BLURB=$(egrep $PATTERN "$ABCDETEMPDIR/status" | tail -n 1)
124
125 if [ -z "$BLURB" ]; then
126 # No matches found
127 return 1
128 else
129 # Matches found
130 # See if there's a = in it
131 if [ "$(echo $BLURB | grep -c =)" != "0" ]; then
132 echo "$(echo $BLURB | cut -f2- -d=)"
133 fi
134 return 0
135 fi
136 }
137
138 # checkerrors [blurb]
139 # Returns "0" if the blurb was found (meaning there was an error),
140 # returns 1 if it wasn't (yes this is a little backwards).
141 # Does not print the blurb on stdout.
142 # Otherwise, returns "".
143 checkerrors ()
144 {
145 if [ -e "$ABCDETEMPDIR/errors" ]; then :; else
146 return 1
147 fi
148 # Take the last line in the status file if there's multiple matches
149 PATTERN="^$1(:.*)?$"
150 BLURB="$(egrep $PATTERN $ABCDETEMPDIR/errors | tail -n 1)"
151
152 if [ -z "$BLURB" ]; then
153 # negative, we did not have a negative...
154 return 1
155 else
156 # affirmative, we had a negative...
157 return 0
158 fi
159 }
160
161 # run_command [blurb] [command...]
162 # Runs a command, silently if necessary, and updates the status file
163 run_command ()
164 {
165 BLURB="$1"
166 shift
167 # See if this is supposed to be silent
168 if [ "$(checkstatus encode-output)" = "loud" ]; then
169 "$@" >&2
170 RETURN=$?
171 else
172 # Special case for SMP, since
173 # encoder output is never displayed, don't mute echos
174 if [ -z "$BLURB" -a "$MAXPROCS" != "1" ]; then
175 "$@" >&2
176 RETURN=$?
177 else
178 "$@" >/dev/null 2>&1
179 RETURN=$?
180 fi
181 fi
182 case "$1" in
183 normalize)
184 if [ "$RETURN" = "2" ]; then
185 # File was already normalized.
186 RETURN=0
187 fi
188 ;;
189 esac
190 if [ "$RETURN" != "0" ]; then
191 # Put an error in the errors file. For various reasons we
192 # can't capture a copy of the program's output but we can
193 # log what we attempted to execute and the error code
194 # returned by the program.
195 if [ "$BLURB" ]; then
196 TWEAK="$BLURB: "
197 fi
198 echo "${TWEAK}returned code $RETURN: $@" >> "$ABCDETEMPDIR/errors"
199 return $RETURN # Do not pass go, do not update the status file
200 fi
201 if [ "$BLURB" ]; then
202 echo $BLURB >> "$ABCDETEMPDIR/status"
203 fi
204 }
205
206 # relpath() and slash() are Copyright (c) 1999 Stuart Ballard and
207 # distributed under the terms of the GNU GPL v2 or later, at your option
208
209 # Function to determine if a word contains a slash.
210 slash ()
211 {
212 case "$1" in
213 */*) return 0;;
214 *) return 1;;
215 esac
216 }
217
218 # Function to give the relative path from one file to another.
219 # Usage: relpath fromfile tofile
220 # eg relpath music/Artist/Album.m3u music/Artist/Album/Song.mp3
221 # (the result would be Album/Song.mp3)
222 # Output is relative path to $2 from $1 on stdout
223
224 # This code has the following restrictions:
225 # Multiple ////s are not collapsed into single /s, with strange effects.
226 # Absolute paths and ../s are handled wrong in FR (but they work in TO)
227 # If FR is a directory it must have a trailing /
228
229 relpath ()
230 {
231 FR="$1"
232 TO="$2"
233
234 case "$TO" in
235 /*) ;; # No processing is needed for absolute paths
236 *)
237 # Loop through common prefixes, ignoring them.
238 while slash "$FR" && [ "$(echo "$FR" | cut -d/ -f1)" = "$(echo "$TO" | cut -d/ -f1)" ]
239 do
240 FR="$(echo "$FR" | cut -d/ -f2-)"
241 TO="$(echo "$TO" | cut -d/ -f2-)"
242 done
243 # Loop through directory portions left in FR, adding appropriate ../s.
244 while slash "$FR"
245 do
246 FR="$(echo "$FR" | cut -d/ -f2-)"
247 TO="../$TO"
248 done
249 ;;
250 esac
251
252 echo $TO
253 }
254
255 # This code splits the a Various Artist track name from one of the following
256 # forms:
257 #
258 # forward: Artist / Track
259 # forward-dash: Artist - Track
260 # reverse: Track / Artist
261 # reverse-dash: Track - Artist
262 # colon: Artist: Track
263 # trailing-paren: Artist (Track)
264 #
265 # variables used:
266 # VARIOUSARTISTS, VARIOUSARTISTSTYLE, TRACKNAME, TRACKARTIST
267 splitvarious ()
268 {
269 if [ "$VARIOUSARTISTS" = "y" ] && [ ! "$ONETRACK" = "y" ]; then
270 case "$VARIOUSARTISTSTYLE" in
271 forward)
272 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's- / -~-g')
273 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f1 -d~)
274 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f2 -d~)
275 ;;
276 forward-dash)
277 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's, - ,~,g')
278 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f1 -d~)
279 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f2 -d~)
280 ;;
281 reverse)
282 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's- / -~-g')
283 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f2 -d~)
284 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f1 -d~)
285 ;;
286 reverse-dash)
287 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's, - ,~,g')
288 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f2 -d~)
289 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f1 -d~)
290 ;;
291 colon)
292 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's-: -~-g')
293 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f1 -d~)
294 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f2 -d~)
295 ;;
296 trailing-paren)
297 DTITLEARTIST=$(echo "$TRACKNAME" | sed 's,^\(.*\) (\(.*\)),\1~\2,')
298 TRACKARTIST=$(echo "$DTITLEARTIST" | cut -f2 -d~)
299 TRACKNAME=$(echo "$DTITLEARTIST" | cut -f1 -d~)
300 ;;
301 esac
302 elif [ "$ONETRACK" = "y" ]; then
303 TRACKARTIST="Various"
304 else
305 TRACKARTIST="$DARTIST"
306 fi
307 }
308
309 do_getgenreid () {
310 local genre=$(echo "${@}" | tr '[A-Z]' '[a-z]')
311 local id=""
312 case ${genre} in
313 "blues") id=0 ;;
314 "classic rock") id=1 ;;
315 "country") id=2 ;;
316 "dance") id=3 ;;
317 "disco") id=4 ;;
318 "funk") id=5 ;;
319 "grunge") id=6 ;;
320 "hip-hop") id=7 ;;
321 "jazz") id=8 ;;
322 "metal") id=9 ;;
323 "new age") id=10 ;;
324 "oldies") id=11 ;;
325 "other") id=12 ;;
326 "pop") id=13 ;;
327 "r&b") id=14 ;;
328 "rap") id=15 ;;
329 "reggae") id=16 ;;
330 "rock") id=17 ;;
331 "techno") id=18 ;;
332 "industrial") id=19 ;;
333 "alternative") id=20 ;;
334 "ska") id=21 ;;
335 "death metal") id=22 ;;
336 "pranks") id=23 ;;
337 "soundtrack") id=24 ;;
338 "euro-techno") id=25 ;;
339 "ambient") id=26 ;;
340 "trip-hop") id=27 ;;
341 "vocal") id=28 ;;
342 "jazz+funk") id=29 ;;
343 "fusion") id=30 ;;
344 "trance") id=31 ;;
345 "classical") id=32 ;;
346 "instrumental") id=33 ;;
347 "acid") id=34 ;;
348 "house") id=35 ;;
349 "game") id=36 ;;
350 "sound clip") id=37 ;;
351 "gospel") id=38 ;;
352 "noise") id=39 ;;
353 "alt. rock") id=40 ;;
354 "bass") id=41 ;;
355 "soul") id=42 ;;
356 "punk") id=43 ;;
357 "space") id=44 ;;
358 "meditative") id=45 ;;
359 "instrum. pop") id=46 ;;
360 "instrum. rock") id=47 ;;
361 "ethnic") id=48 ;;
362 "gothic") id=49 ;;
363 "darkwave") id=50 ;;
364 "techno-indust.") id=51 ;;
365 "electronic") id=52 ;;
366 "pop-folk") id=53 ;;
367 "eurodance") id=54 ;;
368 "dream") id=55 ;;
369 "southern rock") id=56 ;;
370 "comedy") id=57 ;;
371 "cult") id=58 ;;
372 "gangsta") id=59 ;;
373 "top 40") id=60 ;;
374 "christian rap") id=61 ;;
375 "pop/funk") id=62 ;;
376 "jungle") id=63 ;;
377 "native american") id=64 ;;
378 "cabaret") id=65 ;;
379 "new wave") id=66 ;;
380 "psychadelic") id=67 ;;
381 "rave") id=68 ;;
382 "showtunes") id=69 ;;
383 "trailer") id=70 ;;
384 "lo-fi") id=71 ;;
385 "tribal") id=72 ;;
386 "acid punk") id=73 ;;
387 "acid jazz") id=74 ;;
388 "polka") id=75 ;;
389 "retro") id=76 ;;
390 "musical") id=77 ;;
391 "rock & roll") id=78 ;;
392 "hard rock") id=79 ;;
393 "folk") id=80 ;;
394 "folk/rock") id=81 ;;
395 "national folk") id=82 ;;
396 "swing") id=83 ;;
397 "fusion") id=84 ;;
398 "bebob") id=85 ;;
399 "latin") id=86 ;;
400 "revival") id=87 ;;
401 "celtic") id=88 ;;
402 "bluegrass") id=89 ;;
403 "avantgarde") id=90 ;;
404 "gothic rock") id=91 ;;
405 "progress. rock") id=92 ;;
406 "psychadel. rock") id=93 ;;
407 "symphonic rock") id=94 ;;
408 "slow rock") id=95 ;;
409 "big band") id=96 ;;
410 "chorus") id=97 ;;
411 "easy listening") id=98 ;;
412 "acoustic") id=99 ;;
413 "humour") id=100 ;;
414 "speech") id=101 ;;
415 "chanson") id=102 ;;
416 "opera") id=103 ;;
417 "chamber music") id=104 ;;
418 "sonata") id=105 ;;
419 "symphony") id=106 ;;
420 "booty bass") id=107 ;;
421 "primus") id=108 ;;
422 "porn groove") id=109 ;;
423 "satire") id=110 ;;
424 "slow jam") id=111 ;;
425 "club") id=112 ;;
426 "tango") id=113 ;;
427 "samba") id=114 ;;
428 "folklore") id=115 ;;
429 "ballad") id=116 ;;
430 "power ballad") id=117 ;;
431 "rhythmic soul") id=118 ;;
432 "freestyle") id=119 ;;
433 "duet") id=120 ;;
434 "punk rock") id=121 ;;
435 "drum solo") id=122 ;;
436 "a capella") id=123 ;;
437 "euro-house") id=124 ;;
438 "dance hall") id=125 ;;
439 "goa") id=126 ;;
440 "drum & bass") id=127 ;;
441 "club-house") id=128 ;;
442 "hardcore") id=129 ;;
443 "terror") id=130 ;;
444 "indie") id=131 ;;
445 "britpop") id=132 ;;
446 "negerpunk") id=133 ;;
447 "polsk punk") id=134 ;;
448 "beat") id=135 ;;
449 "christian gangsta rap") id=136 ;;
450 "heavy metal") id=137 ;;
451 "black metal") id=138 ;;
452 "crossover") id=139 ;;
453 "contemporary christian")id=140 ;;
454 "christian rock") id=141 ;;
455 "merengue") id=142 ;;
456 "salsa") id=143 ;;
457 "thrash metal") id=144 ;;
458 "anime") id=145 ;;
459 "jpop") id=146 ;;
460 "synthpop") id=147 ;;
461 *) return 1 ;;
462 esac
463 echo ${id}
464 return 0
465 }
466
467 # do_tag [tracknumber]
468 # id3 tags a filename
469 # variables used:
470 # TRACKS, TRACKNAME, TRACKARTIST, TAGGER, TAGGEROPTS, VORBISCOMMENT, METAFLAC,
471 # COMMENT, DALBUM, DARTIST, CDYEAR, CDGENRE (and temporarily) ID3TAGV
472 do_tag ()
473 {
474 COMMENTOUTPUT="$(eval echo ${COMMENT})"
475 run_command '' echo "Tagging track $1 of $TRACKS: $TRACKNAME..."
476 # If we want to start the tracks with a given number, we need to modify the
477 # TRACKNUM value before evaluation
478 if [ -n "$STARTTRACKNUMBER" -a -n "$STARTTRACKNUMBERTAG" ] ; then
479 # Get the trackpadding from the current track
480 CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
481 TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - $FIRSTTRACK ))
482 fi
483 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
484 do
485 case "$OUTPUT" in
486 mp3)
487 # id3v2 v0.1.9 claims to have solved the -c bug, so we merge both id3 and id3v2
488 GENREID=$(do_getgenreid "${CDGENRE}")
489
490 # FIXME # track numbers in mp3 come with 1/10, so we cannot happily substitute them with $TRACKNUM
491 run_command tagtrack-$1 $TAGGER $TAGGEROPTS -c "$COMMENTOUTPUT" \
492 -A "$DALBUM" -a "$TRACKARTIST" -t "$TRACKNAME" -y "$CDYEAR" \
493 -g "$GENREID" -T "${TRACKNUM:-$1/$TRACKS}" \
494 "$ABCDETEMPDIR/track$1.$OUTPUT"
495 ;;
496 ogg)
497 case "$OGGENCODERSYNTAX" in
498 vorbize|oggenc)
499 # vorbiscomment can't do in-place modification, mv the file first
500 if [ -f "$ABCDETEMPDIR/track$1.$OUTPUT" -a ! -f "$ABCDETEMPDIR/track$1.uncommented.$OUTPUT" ]; then
501 mv "$ABCDETEMPDIR/track$1.$OUTPUT" "$ABCDETEMPDIR/track$1.uncommented.$OUTPUT"
502 fi
503 (
504 # These are from http://www.xiph.org/ogg/vorbis/doc/v-comment.html
505 echo ARTIST="$TRACKARTIST"
506 echo ALBUM="$DALBUM"
507 echo TITLE="$TRACKNAME"
508 if [ -n "$CDYEAR" ]; then
509 echo DATE="$CDYEAR"
510 fi
511 if [ -n "$CDGENRE" ]; then
512 echo GENRE="$CDGENRE"
513 fi
514 echo TRACKNUMBER=${TRACKNUM:-$1}
515 echo CDDB=$CDDBDISCID
516 if [ "$(eval echo ${COMMENT})" != "" ]; then
517 case "$COMMENTOUTPUT" in
518 *=*) echo "$COMMENTOUTPUT";;
519 *) echo COMMENT="$COMMENTOUTPUT";;
520 esac
521 fi
522 ) | run_command tagtrack-$1 $VORBISCOMMENT $VORBISCOMMENTOPTS -w \
523 "$ABCDETEMPDIR/track$1.uncommented.$OUTPUT" "$ABCDETEMPDIR/track$1.$OUTPUT"
524 # Doublecheck that the commented file was created successfully before wiping the original
525 if [ -f "$ABCDETEMPDIR/track$1.$OUTPUT" ]; then
526 rm -f "$ABCDETEMPDIR/track$1.uncommented.$OUTPUT"
527 else
528 mv "$ABCDETEMPDIR/track$1.uncommented.$OUTPUT" "$ABCDETEMPDIR/track$1.$OUTPUT"
529 fi
530 ;;
531 esac
532 ;;
533 flac)
534 ## FIXME ## [ "$FLACONOGG" = "y" ] && OUTPUT=ogg
535 (
536 echo ARTIST="$TRACKARTIST"
537 echo ALBUM="$DALBUM"
538 echo TITLE="$TRACKNAME"
539 if [ -n "$CDYEAR" ]; then
540 echo DATE="$CDYEAR"
541 fi
542 if [ -n "$CDGENRE" ]; then
543 echo GENRE="$CDGENRE"
544 fi
545 echo TRACKNUMBER=${TRACKNUM:-$1}
546 echo CDDB=$CDDBDISCID
547 if [ "$(eval echo ${COMMENT})" != "" ]; then
548 case "$COMMENTOUTPUT" in
549 *=*) echo "$COMMENTOUTPUT";;
550 *) echo COMMENT="$COMMENTOUTPUT";;
551 esac
552 fi
553 ) | run_command tagtrack-$1 $METAFLAC $METAFLACOPTS --import-tags-from=- "$ABCDETEMPDIR/track$1.$OUTPUT"
554 ;;
555 spx)
556 run_command tagtrack-$1 true
557 ;;
558 mpc)
559 run_command tagtrack-$1 true
560 ;;
561 esac
562 done
563 }
564
565 # do_batch_encode
566 # variables used:
567 # OUTPUTTYPE, {FOO}ENCODERSYNTAX, ENCNICE, ENCODER, ENCODEROPTS
568 do_batch_encode ()
569 {
570 # The commands here don't go through run_command because they're never supposed to be silenced
571 echo "Batch encoding tracks: $TRACKQUEUE"
572 OUTPUT=$(echo $OUTPUTTYPE | grep "mp3" )
573 case "$OUTPUT" in
574 mp3)
575 case "$MP3ENCODERSYNTAX" in
576 lame)
577 (
578 cd "$ABCDETEMPDIR"
579 TRACKFILES=
580 for UTRACKNUM in $TRACKQUEUE
581 do
582 TRACKFILES="$TRACKFILES track$UTRACKNUM.wav"
583 done
584 nice $ENCNICE $MP3ENCODER $MP3ENCODEROPTS --nogap $TRACKFILES
585 RETURN=$?
586 if [ "$RETURN" != "0" ]; then
587 echo "batch-encode: $ENCODER returned code $RETURN" >> errors
588 else
589 for UTRACKNUM in $TRACKQUEUE
590 do
591 echo encodetrack-$UTRACKNUM >> status
592 done
593 fi
594 )
595 ;;
596 esac
597 ;;
598 esac
599 # Other encoders fall through to normal encoding as the tracks
600 # have not been entered in the status file.
601 }
602
603 # do_encode [tracknumber] [hostname]
604 # If no hostname is specified, encode locally
605 # variables used:
606 # TRACKS, TRACKNAME, TRACKARTIST, DISTMP3, DISTMP3OPTS, {FOO}ENCODERSYNTAX, OUTPUTTYPE, ENCODEROPTS, DALBUM, DARTIST, ENCNICE, CDYEAR, CDGENRE, COMMENT
607 do_encode ()
608 {
609 if [ "$USEPIPES" = "y" ]; then
610 case "$OUTPUT" in
611 mp3)
612 TEMPARG="PIPE_$MP3ENCODERSYNTAX"
613 ;;
614 ogg)
615 TEMPARG="PIPE_$OGGENCODERSYNTAX"
616 ;;
617 flac)
618 TEMPARG="PIPE_$FLACENCODERSYNTAX"
619 ;;
620 spx)
621 TEMPARG="PIPE_$SPEEXENCODER"
622 ;;
623 mpc)
624 TEMPARG="PIPE_$MPPENCODER"
625 ;;
626 esac
627 IN=${!TEMPARG}
628 else
629 IN="$ABCDETEMPDIR/track$1.wav"
630 case "$OUTPUT" in
631 mp3)
632 case "$MP3ENCODERSYNTAX" in
633 # FIXME # check if mp3enc needs -if for pipes
634 mp3enc)
635 FILEARG="-if $IN"
636 ;;
637 *)
638 FILEARG=$IN
639 ;;
640 esac
641 ;;
642 *)
643 FILEARG=$IN
644 ;;
645 esac
646 fi
647 # We need IN to proceed, if we are not using pipes.
648 if [ -s "$IN" -o X"$USEPIPES" = "Xy" ] ; then
649 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
650 do
651 OUT="$ABCDETEMPDIR/track$1.$OUTPUT"
652 if [ X"$USEPIPES" = "Xy" ]; then
653 RUN_COMMAND=""
654 else
655 run_command '' echo "Encoding track $1 of $TRACKS: $TRACKNAME..."
656 RUN_COMMAND="run_command encodetrack-$OUTPUT-$1"
657 fi
658 case "$OUTPUT" in
659 mp3)
660 case "$2" in
661 %local*%)
662 case "$MP3ENCODERSYNTAX" in
663 lame|gogo) $RUN_COMMAND nice $ENCNICE $MP3ENCODER $MP3ENCODEROPTS "$IN" "$OUT" ;;
664 bladeenc) $RUN_COMMAND nice $ENCNICE $MP3ENCODER $MP3ENCODEROPTS -quit "$IN" ;;
665 l3enc|xingmp3enc) $RUN_COMMAND nice $ENCNICE $MP3ENCODER "$IN" "$OUT" $MP3ENCODEROPTS ;;
666 # FIXME # Relates to the previous FIXME since it might need the "-if" removed.
667 mp3enc) $RUN_COMMAND nice $ENCNICE $MP3ENCODER -if "$IN" -of "$OUT" $MP3ENCODEROPTS ;;
668 esac
669 ;;
670 *)
671 $RUN_COMMAND nice $DISTMP3NICE $DISTMP3 $DISTMP3OPTS "$2" "$IN" "$OUT" >/dev/null 2>&1
672 ;;
673 esac
674 ;;
675 ogg)
676 case "$2" in
677 %local*%)
678 case "$OGGENCODERSYNTAX" in
679 vorbize) $RUN_COMMAND nice $ENCNICE $OGGENCODER $OGGENCODEROPTS -w "$OUT" "$IN" ;;
680 oggenc) $RUN_COMMAND nice $ENCNICE $OGGENCODER $OGGENCODEROPTS -o "$OUT" "$IN" ;;
681 esac
682 ;;
683 *)
684 $RUN_COMMAND nice $DISTMP3NICE $DISTMP3 $DISTMP3OPTS "$2" "$IN" "$OUT" >/dev/null 2>&1
685 ;;
686 esac
687 ;;
688 flac)
689 case "$2" in
690 %local*%)
691 case "$FLACENCODERSYNTAX" in
692 flac) $RUN_COMMAND nice $ENCNICE $FLACENCODER $FLACENCODEROPTS -o "$OUT" "$IN" ;;
693 esac
694 ;;
695
696 *)
697 echo -n "DISTMP3:"
698 echo "$DISTMP3 $DISTMP3OPTS $2 $IN $OUT >/dev/null 2>&1"
699 $RUN_COMMAND nice $DISTMP3NICE $DISTMP3 $DISTMP3OPTS "$2" "$IN" "$OUT" > /dev/null 2>&1
700 ;;
701 esac
702 ;;
703 spx)
704 if [ "$(eval echo ${COMMENT})" != "" ]; then
705 case "$COMMENT" in
706 *=*) ;;
707 *) COMMENT="COMMENT=$COMMENT" ;;
708 esac
709 COMMENT="--comment \"$COMMENT\""
710 fi
711 # Quick hack to avoid tagging Ogg/Speex, since there is no other way to tag than inline tagging
712 if [ ! "$DOTAG" = "y" ]; then
713 $RUN_COMMAND nice $ENCNICE $SPEEXENCODER $SPEEXENCODEROPTS --author "$TRACKARTIST" --title "$TRACKNAME" "$COMMENT" "$IN" "$OUT"
714 else
715 $RUN_COMMAND nice $ENCNICE $SPEEXENCODER $SPEEXENCODEROPTS "$IN" "$OUT"
716 fi
717 ;;
718 mpc)
719 # MPP/MP+(Musepack) format (.mpc) is done locally, with inline
720 # tagging.
721 # I tried compiling the mppenc from corecodecs.org and got some
722 # errors, so I have not tried it myself.
723 ## FIXME ## Needs some cleanup to determine if an empty tag sent
724 ## FIXME ## to the encoder ends up empty.
725 $RUN_COMMAND nice $ENCNICE $MPPENCODER $MPPENCODEROPTS --artist "$TRACKARTIST" --album "$DALBUM" --title "$TRACKNAME" --track "$1" --genre "$CDGENRE" --year "$CDYEAR" --comment "$COMMENT" "$IN" "$OUT"
726 ;;
727 esac
728 done
729 # Only remove .wav if the encoding succeeded
730 if checkerrors "encodetrack-(.{3,4})-$1"; then
731 run_command encodetrack-$1 false
732 else
733 run_command encodetrack-$1 true
734 if [ ! "$KEEPWAVS" = "y" ] ; then
735 rm -f "$IN"
736 fi
737 fi
738 else
739 if [ "$(checkstatus encode-output)" = "loud" ]; then
740 echo "HEH! The file we were about to encode disappeared:"
741 echo ">> $IN"
742 fi
743 run_command encodetrack-$1 false
744 fi
745 }
746
747 # do_preprocess [tracknumber]
748 # variables used:
749 # TRACKS, TRACKNAME, TRACKARTIST, DISTMP3, DISTMP3OPTS, {FOO}ENCODERSYNTAX, OUTPUTTYPE, ENCODEROPTS, DALBUM, DARTIST, ENCNICE, CDYEAR, CDGENRE, COMMENT
750 #do_preprocess ()
751 #{
752 # IN="$ABCDETEMPDIR/track$1.wav"
753 # # We need IN to proceed.
754 # if [ -s "$IN" ] ; then
755 # for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
756 # do
757 # #OUT="$ABCDETEMPDIR/track$1.$OUTPUT"
758 # run_command '' echo "Pre-processing track $1 of $TRACKS..."
759 # case "$POSTPROCESSFORMAT" in
760 # all|wav*)
761 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $WAV_PRE $IF $OF ;;
762 # mp3)
763 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $MP3_PRE $IF $OF ;;
764 # ogg)
765 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $OGG_PRE $IF $OF ;;
766 # flac)
767 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $FLAC_PRE $IF $OF ;;
768 # spx)
769 # run_command preprocess-$OUTPUT-$1 nice $PRENICE $SPX_PRE $IF $OF ;;
770 # esac
771 # done
772 # # Only remove .wav if the encoding succeeded
773 # if checkerrors "preprocess-(.{3,4})-$1"; then
774 # run_command preprocess-$1 false
775 # else
776 # run_command preprocess-$1 true
777 # fi
778 # else
779 # if [ "$(checkstatus encode-output)" = "loud" ]; then
780 # echo "HEH! The file we were about to pre-process disappeared:"
781 # echo ">> $IN"
782 # fi
783 # run_command preprocess-$1 false
784 # fi
785 #}
786
787
788 # do_postprocess [tracknumber]
789 # variables used:
790 # TRACKS, TRACKNAME, TRACKARTIST, DISTMP3, DISTMP3OPTS, {FOO}ENCODERSYNTAX, OUTPUTTYPE, ENCODEROPTS, DALBUM, DARTIST, ENCNICE, CDYEAR, CDGENRE, COMMENT
791 #do_postprocess ()
792 #{
793 # for POSTPROCESSFORMAT in $(echo $POSTPROCESSFORMATS | tr , \ )
794 # do
795 # IN="$ABCDETEMPDIR/track$1.$POSTPROCESSFORMAT"
796 # # We need IN to proceed.
797 # if [ -s "$IN" ] ; then
798 # #OUT="$ABCDETEMPDIR/track$1.$OUTPUT"
799 # run_command '' echo "Post-processing track $1 of $TRACKS..."
800 # case "$POSTPROCESSFORMAT" in
801 # mp3)
802 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $MP3_POST $IF $OF ;;
803 # ogg)
804 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $OGG_POST $IF $OF ;;
805 # flac)
806 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $FLAC_POST $IF $OF ;;
807 # spx)
808 # run_command postprocess-$OUTPUT-$1 nice $POSTNICE $SPX_POST $IF $OF ;;
809 # esac
810 # # Only remove .wav if the encoding succeeded
811 # if checkerrors "postprocess-(.{3,4})-$1"; then
812 # run_command postprocess-$1 false
813 # else
814 # run_command postprocess-$1 true
815 # fi
816 # else
817 # if [ "$(checkstatus encode-output)" = "loud" ]; then
818 # echo "HEH! The file we were about to post-process disappeared:"
819 # echo ">> $IN"
820 # fi
821 # run_command postprocess-$1 false
822 # fi
823 # done
824 #}
825
826 # do_single_gain
827 # variables used:
828 # FIXME #
829 do_single_gain ()
830 {
831 :
832 }
833
834 # do_batch_gain
835 # variables used:
836 # MP3GAIN, MP3GAINOPTS, VORBISGAIN, VORBISGAINOPTS
837 # FIXME #
838 do_batch_gain ()
839 {
840 # The commands here don't go through run_command because they're never supposed to be silenced
841 echo "Batch analizing gain in tracks: $TRACKQUEUE"
842 (
843 cd "$ABCDETEMPDIR"
844 BLURB=
845 TRACKFILES=
846 for UTRACKNUM in $TRACKQUEUE
847 do
848 MP3FILES="$TRACKFILES track$UTRACKNUM.mp3"
849 done
850 # XXX: Hard-coded batch option!
851 $NORMALIZER -b $NORMALIZEROPTS $TRACKFILES
852 RETURN=$?
853 if [ "$RETURN" != "0" ]; then
854 echo "batch-normalize: $NORMALIZER returned code $RETURN" >> errors
855 else
856 for UTRACKNUM in $TRACKQUEUE
857 do
858 echo normalizetrack-$UTRACKNUM >> status
859 done
860 fi
861 )
862 }
863
864 # do_batch_normalize
865 # variables used:
866 # NORMALIZER, NORMALIZEROPTS
867 do_batch_normalize ()
868 {
869 # The commands here don't go through run_command because they're never supposed to be silenced
870 echo "Batch normalizing tracks: $TRACKQUEUE"
871 (
872 cd "$ABCDETEMPDIR"
873 BLURB=
874 TRACKFILES=
875 for UTRACKNUM in $TRACKQUEUE
876 do
877 TRACKFILES="$TRACKFILES track$UTRACKNUM.wav"
878 done
879 # XXX: Hard-coded batch option!
880 $NORMALIZER -b $NORMALIZEROPTS $TRACKFILES
881 RETURN=$?
882 if [ "$RETURN" != "0" ]; then
883 echo "batch-normalize: $NORMALIZER returned code $RETURN" >> errors
884 else
885 for UTRACKNUM in $TRACKQUEUE
886 do
887 echo normalizetrack-$UTRACKNUM >> status
888 done
889 fi
890 )
891 }
892
893 # do_normalize [tracknumber]
894 # variables used:
895 # TRACKS, TRACKNAME, NORMALIZER, NORMALIZEROPTS
896 do_normalize ()
897 {
898 IN="$ABCDETEMPDIR/track$1.wav"
899 if [ -e "$IN" ] ; then
900 run_command '' echo "Normalizing track $1 of $TRACKS: $TRACKNAME..."
901 run_command normalizetrack-$1 $NORMALIZER $NORMALIZEROPTS "$IN"
902 else
903 if [ "$(checkstatus encode-output)" = "loud" ]; then
904 echo "HEH! The file we were about to normalize disappeared:"
905 echo ">> $IN"
906 fi
907 run_command normalizetrack-$1 false "File $IN was not found"
908 fi
909 }
910
911 # do_move [tracknumber]
912 # Deduces the outfile from environment variables
913 # Creates directory if necessary
914 # variables used:
915 # TRACKNUM, TRACKNAME, TRACKARTIST, DALBUM, OUTPUTFORMAT, CDGENRE, CDYEAR
916 do_move ()
917 {
918 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
919 do
920 # Create ALBUMFILE, ARTISTFILE, TRACKFILE
921 # Munge filenames as follows:
922 # ' ' -> '_'
923 # '/' -> '_'
924 # ''' -> ''
925 # '?' -> ''
926 # Eat control characters
927 ALBUMFILE=$(mungefilename "$DALBUM")
928 ARTISTFILE=$(mungefilename "$TRACKARTIST")
929 TRACKFILE=$(mungefilename "$TRACKNAME")
930 GENRE=$(mungegenre "$GENRE")
931 YEAR=$(echo $CDYEAR)
932 # If we want to start the tracks with a given number, we need to modify the
933 # TRACKNUM value before evaluation
934 if [ -n "$STARTTRACKNUMBER" ] ; then
935 # Get the trackpadding from the current track
936 CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
937 TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - $FIRSTTRACK ))
938 else
939 TRACKNUM=${UTRACKNUM}
940 fi
941 # Supported variables for OUTPUTFORMAT are GENRE, ALBUMFILE, ARTISTFILE,
942 # TRACKFILE, and TRACKNUM.
943 if [ "$VARIOUSARTISTS" = "y" ]; then
944 OUTPUTFILE=$(eval echo $VAOUTPUTFORMAT)
945 else
946 OUTPUTFILE=$(eval echo $OUTPUTFORMAT)
947 fi
948 # Check that the directory for OUTPUTFILE exists, if it doesn't, create it
949 OUTPUTFILEDIR=$(dirname "$OUTPUTDIR/$OUTPUTFILE")
950 # mkdir -p shouldn't return an error if the directory already exists
951 mkdir -p "$OUTPUTFILEDIR"
952 run_command movetrack-$1 mv "$ABCDETEMPDIR/track$1.$OUTPUT" "$OUTPUTDIR/$OUTPUTFILE.$OUTPUT"
953 done
954 }
955
956 # do_playlist
957 # Create the playlist if wanted
958 # Variables used:
959 # PLAYLISTFORMAT, PLAYLISTDATAPREFIX, VAPLAYLISTFORMAT, VAPLAYLISTDATAPREFIX,
960 # VARIOUSARTISTS, OUTPUTDIR
961 do_playlist ()
962 {
963 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
964 do
965 # Create a playlist file for the playlist data to go into.
966 # We used to wipe it out if it existed. Now we request permision if interactive.
967 for LASTTRACK in $TRACKQUEUE; do :; done
968 ALBUMFILE=$(mungefilename "$DALBUM")
969 ARTISTFILE=$(mungefilename "$DARTIST")
970 GENRE=$(mungegenre "$GENRE")
971 if [ "$VARIOUSARTISTS" = "y" ] ; then
972 PLAYLISTFILE=$(eval echo $VAPLAYLISTFORMAT)
973 else
974 PLAYLISTFILE=$(eval echo $PLAYLISTFORMAT)
975 fi
976 FINALPLAYLISTDIR=$(dirname "$OUTPUTDIR/$PLAYLISTFILE")
977 mkdir -p "$FINALPLAYLISTDIR"
978 if [ -s "$OUTPUTDIR/$PLAYLISTFILE" ]; then
979 echo -n "Erase, Append to, or Keep the existing playlist file? [e/a/k] (e): " >&2
980 if [ "$INTERACTIVE" = "y" ]; then
981 while [ "$DONE" != "y" ]; do
982 read ERASEPLAYLIST
983 case $ERASEPLAYLIST in
984 e|E|a|A|k|K) DONE=y ;;
985 *) ;;
986 esac
987 done
988 else
989 echo e >&2
990 ERASEPLAYLIST=e
991 fi
992 # Once we erase the playlist, we use append to create the new one.
993 [ "$ERASEPLAYLIST" = "e" -o "$ERASEPLAYLIST" = "E" ] && rm -f "$OUTPUTDIR/$PLAYLISTFILE" && ERASEPLAYLIST=a
994 else
995 # The playlist does not exist, so we can safelly use append to create the new list
996 ERASEPLAYLIST=a
997 fi
998 if [ "$ERASEPLAYLIST" = "a" -o "$ERASEPLAYLIST" = "A" ]; then
999 touch "$OUTPUTDIR/$PLAYLISTFILE"
1000 for UTRACKNUM in $TRACKQUEUE
1001 do
1002 # Shares some code with do_move since the filenames have to match
1003 CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
1004 TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2 -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')
1005 splitvarious
1006 TRACKFILE=$(mungefilename "$TRACKNAME")
1007 ARTISTFILE=$(mungefilename "$TRACKARTIST")
1008 # If we want to start the tracks with a given number, we need to modify the
1009 # TRACKNUM value before evaluation
1010 if [ -n "$STARTTRACKNUMBER" ] ; then
1011 # Get the trackpadding from the current track
1012 CURRENTTRACKPADDING=$(echo -n $UTRACKNUM | wc -c)
1013 TRACKNUM=$( printf %0.${CURRENTTRACKPADDING}d $(expr ${UTRACKNUM} + ${STARTTRACKNUMBER} - $FIRSTTRACK ))
1014 else
1015 TRACKNUM=${UTRACKNUM}
1016 fi
1017 if [ "$VARIOUSARTISTS" = "y" ]; then
1018 OUTPUTFILE=$(eval echo $VAOUTPUTFORMAT)
1019 else
1020 OUTPUTFILE=$(eval echo $OUTPUTFORMAT)
1021 fi
1022 if [ "$VARIOUSARTISTS" = "y" ]; then
1023 if [ "$VAPLAYLISTDATAPREFIX" ] ; then
1024 echo ${VAPLAYLISTDATAPREFIX}$OUTPUTFILE.$OUTPUT >> "$OUTPUTDIR/$PLAYLISTFILE"
1025 else
1026 relpath "$PLAYLISTFILE", "$OUTPUTFILE.$OUTPUT" >> "$OUTPUTDIR/$PLAYLISTFILE"
1027 fi
1028 else
1029 if [ "$PLAYLISTDATAPREFIX" ]; then
1030 echo ${PLAYLISTDATAPREFIX}$OUTPUTFILE.$OUTPUT >> "$OUTPUTDIR/$PLAYLISTFILE"
1031 else
1032 relpath "$PLAYLISTFILE", "$OUTPUTFILE.$OUTPUT" >> "$OUTPUTDIR/$PLAYLISTFILE"
1033 fi
1034 fi
1035 done
1036 fi
1037 ## this will convert the playlist to have CRLF line-endings, if specified
1038 ## (some hardware players insist on CRLF endings)
1039 if [ "$DOSPLAYLIST" = "y" ]; then
1040 awk '{substr("\r",""); printf "%s\r\n", $0}' "$OUTPUTDIR/$PLAYLISTFILE" > "$ABCDETEMPDIR/PLAYLISTFILE.tmp"
1041 # mv -f "$ABCDETEMPDIR/PLAYLISTFILE.tmp" "$OUTPUTDIR/$PLAYLISTFILE"
1042 cat "$ABCDETEMPDIR/PLAYLISTFILE.tmp" | sed 's/\//\\/' > "$OUTPUTDIR/$PLAYLISTFILE"
1043 fi
1044 echo "playlistcomplete" >> "$ABCDETEMPDIR/status"
1045 done
1046 }
1047
1048 # do_discid
1049 # This essentially the start of things
1050 do_discid ()
1051 {
1052 # Query the CD to get the track info, unless the user specified -C
1053 # or we are using some actions which do not need the CDDB data at all
1054 #if [ ! X"$EXPACTIONS" = "X" ]; then
1055 # :
1056 #elif [ -z "$DISCID" ]; then
1057 if [ -z "$DISCID" ]; then
1058 vecho -n "Getting CD track info... "
1059 if [ "$OSFLAVOUR" = "OSX" ]; then
1060 disktool -u ${CDROM#/dev/}
1061 fi
1062 TRACKINFO=$($CDDISCID $CDROM)
1063 if [ "$OSFLAVOUR" = "OSX" ]; then
1064 disktool -m ${CDROM#/dev/}
1065 fi
1066 # Make sure there's a CD in there by checking cd-discid's return code
1067 if [ "$?" = "1" ]; then
1068 echo "abcde error: CD could not be read. Perhaps there's no CD in the drive?" >&2
1069 exit 1
1070 fi
1071 WEHAVEACD=y
1072 else
1073 TRACKINFO=$(cat "$WAVOUTPUTDIR/abcde.$DISCID/discid")
1074 fi
1075
1076 # Get a full enumeration of tracks, sort it, and put it in the TRACKQUEUE.
1077 # This needs to be done now because a section of the resuming code will need
1078 # it later.
1079
1080 # get the number of digits to pad TRACKNUM with - we'll use this later
1081 # a CD can only hold 99 tracks, but since we support a feature for starting
1082 # numbering the tracks from a given number, we might need to set it as a
1083 # variable for the user to define... or obtain it somehow.
1084 if [ "$PADTRACKS" = "y" ] ; then
1085 TRACKNUMPADDING=2
1086 fi
1087
1088 ABCDETEMPDIR="$WAVOUTPUTDIR/abcde.$(echo $TRACKINFO | cut -f1 -d' ')"
1089 if [ -z "$TRACKQUEUE" ]; then
1090 if [ ! "$STRIPDATATRACKS" = "y" ]; then
1091 case "$CDROMREADERSYNTAX" in
1092 cdparanoia|debug)
1093 if [ "$WEHAVEACD" = "y" ]; then
1094 vecho "Querying the CD for audio tracks..."
1095 CDPARANOIAOUTPUT="$( $CDROMREADER -d $CDROM -Q --verbose 2>&1 )"
1096 RET=$?
1097 if [ ! "$RET" = "0" ];then
1098 echo "Warning: Something went wrong while querying the CD... Maybe a DATA CD?"
1099 fi
1100 TRACKS="$( echo "$CDPARANOIAOUTPUT" | egrep '^[[:space:]]+[[:digit:]]' | tail -n 1 | get_first | tr -d "." | tr '\n' ' ' )"
1101 CDPARANOIAAUDIOTRACKS="$TRACKS"
1102 else
1103 if [ -f "$ABCDETEMPDIR/status" ] && checkstatus cdparanoia-audio-tracks ; then
1104 TRACKS=$( cat $ABCDETEMPDIR/cdparanoia-audio-tracks )
1105 else
1106 TRACKS=$(echo $TRACKINFO | cut -f2 -d' ')
1107 fi
1108 fi
1109 ;;
1110 *) TRACKS=$(echo $TRACKINFO | cut -f2 -d' ') ;;
1111 esac
1112 else
1113 TRACKS=$(echo $TRACKINFO | cut -f2 -d' ')
1114 fi
1115 if echo "$TRACKS" | grep "[[:digit:]]" > /dev/null 2>&1 ;then :;else
1116 echo "The disc does not contain any tracks. Giving up..."
1117 exit 0
1118 fi
1119 echo -n "Grabbing entire CD - tracks: "
1120 if [ ! "$PADTRACKS" = "y" ] ; then
1121 TRACKNUMPADDING=$(echo -n $TRACKS | wc -c | tr -d ' ')
1122 fi
1123 TRACKS=$(printf "%0.${TRACKNUMPADDING}d" $TRACKS)
1124 X=0
1125 while [ "$X" -ne "$TRACKS" ]
1126 do
1127 X=$(printf "%0.${TRACKNUMPADDING}d" $(expr $X + 1))
1128 TRACKQUEUE=$(echo "$TRACKQUEUE" $X)
1129 done
1130 echo $TRACKQUEUE
1131 else
1132 TRACKS=$(echo $TRACKINFO | cut -f2 -d' ')
1133 # User-supplied track queue.
1134 # Weed out non-numbers, whitespace, then sort and weed out duplicates
1135 TRACKQUEUE=$(echo $TRACKQUEUE | sed 's-[^0-9 ]--g' | tr ' ' '\n' | grep -v ^$ | sort -n | uniq | tr '\n' ' ' | sed 's- $--g')
1136 # Once cleaned, obtain the highest value in the trackqueue for number padding
1137 for LASTTRACK in $TRACKQUEUE; do :; done
1138 if [ ! "$PADTRACKS" = "y" ] ; then
1139 TRACKNUMPADDING=$(echo -n $LASTTRACK | wc -c | tr -d ' ')
1140 fi
1141 # Now we normalize the trackqueue
1142 for TRACK in $TRACKQUEUE ; do
1143 TRACKNUM=$(printf %0.${TRACKNUMPADDING}d $(expr ${TRACK} + 0 ))
1144 PADTRACKQUEUE=$(echo $PADTRACKQUEUE $TRACKNUM)
1145 done
1146 TRACKQUEUE=$PADTRACKQUEUE
1147 echo Grabbing tracks: "$TRACKQUEUE"
1148 fi
1149
1150 QUEUEDTRACKS=$(echo $TRACKQUEUE | wc -w | tr -d ' ')
1151
1152 # We have the discid, create a temp directory after it to store all the temp
1153 # info
1154
1155 if [ -e "$ABCDETEMPDIR" ]; then
1156 echo -n "abcde: attempting to resume from $ABCDETEMPDIR"
1157 # It already exists, see if it's a directory
1158 if [ ! -d "$ABCDETEMPDIR" ]; then
1159 # This is a file/socket/fifo/device/etc, not a directory
1160 # Complain and exit
1161 echo >&2
1162 echo "abcde: file $ABCDETEMPDIR already exists and does not belong to abcde." >&2
1163 echo "Please investigate, remove it, and rerun abcde." >&2
1164 exit 1
1165 fi
1166 echo -n .
1167 # It's a directory, let's see if it's owned by us
1168 if [ ! -O "$ABCDETEMPDIR" ]; then
1169 # Nope, complain and exit
1170 echo >&2
1171 echo "abcde: directory $ABCDETEMPDIR already exists and is not owned by you." >&2
1172 echo "Please investigate, remove it, and rerun abcde." >&2
1173 exit 1
1174 fi
1175 echo .
1176 # See if it's populated
1177 if [ ! -f "$ABCDETEMPDIR/discid" ]; then
1178 # Wipe and start fresh
1179 echo "abcde: $ABCDETEMPDIR/discid not found. Abcde must remove and recreate" >&2
1180 echo -n "this directory to continue. Continue? [y/n] (n)" >&2
1181 if [ "$INTERACTIVE" = "y" ]; then
1182 read ANSWER
1183 else
1184 echo y >&2
1185 ANSWER=y
1186 fi
1187 if [ "$ANSWER" != "y" ]; then
1188 exit 1
1189 fi
1190 rm -rf "$ABCDETEMPDIR" || exit 1
1191 mkdir "$ABCDETEMPDIR"
1192 if [ "$?" -gt "0" ]; then
1193 # Directory already exists or could not be created
1194 echo "abcde: Temp directory $ABCDETEMPDIR could not be created." >&2
1195 exit 1
1196 fi
1197 else
1198 # Everything is fine. Check for ^encodetracklocation-
1199 # and encode-output entries in the status file and
1200 # remove them. These are not relevant across sessions.
1201 if [ -f "$ABCDETEMPDIR/status" ]; then
1202 mv "$ABCDETEMPDIR/status" "$ABCDETEMPDIR/status.old"
1203 grep -v ^encodetracklocation- < "$ABCDETEMPDIR/status.old" \
1204 | grep -v ^encode-output > "$ABCDETEMPDIR/status"
1205 fi
1206 # Remove old error messages
1207 if [ -f "$ABCDETEMPDIR/errors" ]; then
1208 rm -f "$ABCDETEMPDIR/errors"
1209 fi
1210 fi
1211 else
1212 # We are starting from scratch
1213 mkdir "$ABCDETEMPDIR"
1214 if [ "$?" -gt "0" ]; then
1215 # Directory already exists or could not be created
1216 echo "abcde: Temp directory $ABCDETEMPDIR could not be created." >&2
1217 exit 1
1218 fi
1219 cat /dev/null > "$ABCDETEMPDIR/status"
1220 fi
1221 if [ X"$CUEFILE" = "Xy" -a X"$WEHAVEACD" = "Xy" ]; then
1222 if checkstatus cuefile >/dev/null ; then :; else
1223 CUEFILE=cue-$(echo $TRACKINFO | cut -f3 -d' ').txt
1224 $MKCUE $MKCUEOPTS > $ABCDETEMPDIR/$CUEFILE
1225 echo cuefile=$CUEFILE >> "$ABCDETEMPDIR/status"
1226 fi
1227 fi
1228 # If we got the CDPARANOIA status and it is not recorded, save it now
1229 if [ -n "$CDPARANOIAAUDIOTRACKS" ]; then
1230 if checkstatus cdparanoia-audio-tracks; then :; else
1231 if echo "$CDPARANOIAAUDIOTRACKS" >> "$ABCDETEMPDIR/cdparanoia-audio-tracks"; then
1232 echo "cdparanoia-audio-tracks" >> "$ABCDETEMPDIR/status"
1233 fi
1234 fi
1235 fi
1236
1237 # Create the discid file
1238 echo "$TRACKINFO" > "$ABCDETEMPDIR/discid"
1239 }
1240
1241 # do_cleancue
1242 # Create a proper CUE file based on the CUE file we created before.
1243 do_cleancue()
1244 {
1245 if checkstatus cuefile; then :; else
1246 $CUEFILE_INPUT="$ABCDETEMPDIR/cue-$(echo $TRACKINFO | cut -f1 -d' ').txt"
1247 ### FIXME ### checkstatus cddb
1248 if [ "$DOCDDB" = "y" ]; then
1249 MARKER
1250 fi
1251 fi
1252 }
1253
1254 # do_cddbparse
1255 # Parses a CDDB file and outputs the title and the track names.
1256 # Variables: CDDBFILE
1257 do_cddbparse ()
1258 {
1259 CDDBPARSEFILE="$1"
1260 # List out disc title/author and contents
1261 if [ "$ONETRACK" = "y" ]; then
1262 vecho "ONETRACK mode selected: displaying only the title of the CD..."
1263 fi
1264 echo "---- $(grep DTITLE "${CDDBPARSEFILE}" | cut '-d=' -f2- | tr -d \\r\\n ) ----"
1265 if [ ! "$ONETRACK" = "y" ]; then
1266 for TRACK in $(f_seq_row 1 $TRACKS)
1267 do
1268 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "${CDDBPARSEFILE}" | cut -f2- -d= | tr -d \\r\\n)"
1269 done
1270 fi
1271 }
1272
1273 # do_localcddb
1274 # Check for a local CDDB file, and report success
1275 do_localcddb ()
1276 {
1277 if checkstatus cddb-readcomplete && checkstatus cddb-choice >/dev/null; then :; else
1278
1279 CDDBLOCALSUCCESS="n"
1280 CDDBDISCID=$(echo $TRACKINFO | cut -d' ' -f1)
1281 CDDBLOCALFILE="${CDDBLOCALDIR}/${CDDBDISCID}"
1282 USELOCALRESP="y"
1283
1284 # If the user has selected to check a local CDDB repo, we proceed with it
1285 if [ -r "${CDDBLOCALFILE}" ]; then
1286 # List out disc title/author and contents
1287 do_cddbparse "${CDDBLOCALFILE}"
1288 echo -n "Locally cached CDDB entry found, use it? [y/n] (y): "
1289 if [ "$INTERACTIVE" = "y" ]; then
1290 read USELOCALRESP
1291 while [ "$USELOCALRESP" != "y" ] && [ "$USELOCALRESP" != "n" ] && [ "$USELOCALRESP" != "" ] ; do
1292 echo -n 'Invalid selection. Please answer "y" or "n": '
1293 read USELOCALRESP
1294 done
1295 [ x"$USELOCALRESP" = "x" ] && USELOCALRESP="y"
1296 else
1297 echo "y" >&2
1298 fi
1299 if [ "$USELOCALRESP" = "y" ]; then
1300 #echo "Using local copy of CDDB data"
1301 cp "${CDDBLOCALFILE}" "$ABCDETEMPDIR/cddbread.1"
1302 echo 999 > "$ABCDETEMPDIR/cddbquery" # Assuming 999 isn't used by CDDB
1303 echo cddb-readcomplete >> "$ABCDETEMPDIR/status"
1304 do_cddbparse "${CDDBLOCALFILE}" > "$ABCDETEMPDIR/cddbchoices"
1305 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1306 CDDBLOCALSUCCESS="y"
1307 else
1308 #echo "Not using local copy of CDDB data"
1309 CDDBLOCALSUCCESS="n"
1310 fi
1311 else
1312 CDDBLOCALSUCCESS="n"
1313 fi
1314 fi
1315 }
1316
1317 # do_cddbstat
1318 do_cddbstat ()
1319 {
1320 # Perform CDDB protocol version check if it hasn't already been done
1321 if checkstatus cddb-statcomplete; then :; else
1322 if [ "$CDDBAVAIL" = "n" ]; then
1323 ERRORCODE=no_query
1324 echo 503 > "$ABCDETEMPDIR/cddbstat"
1325 else
1326 rc=1
1327 CDDBUSER=$(echo $HELLOINFO | cut -f1 -d'@')
1328 CDDBHOST=$(echo $HELLOINFO | cut -f2- -d'@')
1329 while test $rc -eq 1 -a $CDDBPROTO -ge 3; do
1330 vecho "Checking CDDB server status..."
1331 $CDDBTOOL stat $CDDBURL $CDDBUSER $CDDBHOST $CDDBPROTO > "$ABCDETEMPDIR/cddbstat"
1332 RESPONSECODE=$(head -n 1 "$ABCDETEMPDIR/cddbstat" | cut -f1 -d' ')
1333 case "$RESPONSECODE" in
1334 210) # 210 OK, status information follows (until terminating `.')
1335 rc=0;
1336 ;;
1337 501|*) # 501 Illegal CDDB protocol level: <n>.
1338 CDDBPROTO=`expr $CDDBPROTO - 1`
1339 ;;
1340 esac
1341 done
1342 if test $rc -eq 1; then
1343 CDDBAVAIL="n"
1344 fi
1345 fi
1346 echo cddb-statcomplete >> "$ABCDETEMPDIR/status"
1347 fi
1348 }
1349
1350
1351 # do_cddbquery
1352 do_cddbquery ()
1353 {
1354 CDDBDISCID=$(echo $TRACKINFO | cut -d' ' -f1)
1355 CDDBLOCALFILE="${CDDBLOCALDIR}/${CDDBDISCID}"
1356
1357 # Perform CDDB query if it hasn't already been done
1358 if checkstatus cddb-querycomplete; then :; else
1359 if [ "$CDDBAVAIL" = "n" ]; then
1360 ERRORCODE=no_query
1361 echo 503 > "$ABCDETEMPDIR/cddbquery"
1362 # The default CDDBLOCALSUCCESS is "n"
1363 # This part will be triggered if the user CDDB repo does not
1364 # contain the entry, or if we are not trying to use the repo.
1365 else
1366 vecho "Querying the CDDB server..."
1367 CDDBUSER=$(echo $HELLOINFO | cut -f1 -d'@')
1368 CDDBHOST=$(echo $HELLOINFO | cut -f2- -d'@')
1369 $CDDBTOOL query $CDDBURL $CDDBPROTO $CDDBUSER $CDDBHOST $TRACKINFO > "$ABCDETEMPDIR/cddbquery"
1370 ERRORCODE=$?
1371 case $ERRORCODE in
1372 0) # success
1373 ;;
1374 12|13|14)
1375 # no match found in database,
1376 # wget/fetch error, or user requested not to use CDDB
1377 # Make up an error code (503) that abcde
1378 # will recognize in do_cddbread
1379 # and compensate by making a template
1380 echo 503 > "$ABCDETEMPDIR/cddbquery"
1381 ;;
1382 *) # strange and unknown error
1383 echo ERRORCODE=$ERRORCODE
1384 echo "abcde: $CDDBTOOL returned unknown error code"
1385 ;;
1386 esac
1387 fi
1388 echo cddb-querycomplete >> "$ABCDETEMPDIR/status"
1389 fi
1390 }
1391
1392 # do_cddbread
1393 do_cddbread ()
1394 {
1395 # If it's not to be used, generate a template.
1396 # Then, display it (or them) and let the user choose/edit it
1397 if checkstatus cddb-readcomplete; then :; else
1398 vecho "Obtaining CDDB results..."
1399 # If CDDB is to be used, interpret the query results and read all
1400 # the available entries.
1401 rm -f "$ABCDETEMPDIR/cddbchoices"
1402 CDDBCHOICES=1 # Overridden by multiple matches
1403 RESPONSECODE=$(head -n 1 "$ABCDETEMPDIR/cddbquery" | cut -f1 -d' ')
1404 case "$RESPONSECODE" in
1405 200)
1406 # One exact match, retrieve it
1407 # 200 [section] [discid] [artist] / [title]
1408 if checkstatus cddb-read-1-complete; then :; else
1409 echo -n "Retrieving 1 CDDB match..." >> "$ABCDETEMPDIR/cddbchoices"
1410 $CDDBTOOL read $CDDBURL $CDDBPROTO $CDDBUSER $CDDBHOST $(cut -f2,3 -d' ' "$ABCDETEMPDIR/cddbquery") > "$ABCDETEMPDIR/cddbread.1"
1411 echo "done." >> "$ABCDETEMPDIR/cddbchoices"
1412 echo cddb-read-1-complete >> "$ABCDETEMPDIR/status"
1413 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1414 fi
1415 # List out disc title/author and contents
1416 echo ---- "$(cut '-d ' -f4- "$ABCDETEMPDIR/cddbquery")" ---- >> "$ABCDETEMPDIR/cddbchoices"
1417 for TRACK in $(f_seq_row 1 $TRACKS)
1418 do
1419 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.1" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1420 done
1421 echo >> "$ABCDETEMPDIR/cddbchoices"
1422 ;;
1423 202|403|409|503)
1424 # No match
1425 case "$RESPONSECODE" in
1426 202) echo "No CDDB match." >> "$ABCDETEMPDIR/cddbchoices" ;;
1427 403|409) echo "CDDB entry is corrupt, or the handshake failed." >> "$ABCDETEMPDIR/cddbchoices" ;;
1428 503) echo "CDDB unavailable." >> "$ABCDETEMPDIR/cddbchoices" ;;
1429 esac
1430 $CDDBTOOL template $(cat "$ABCDETEMPDIR/discid") > "$ABCDETEMPDIR/cddbread.0"
1431 # List out disc title/author and contents of template
1432 echo ---- Unknown Artist / Unknown Album ---- >> "$ABCDETEMPDIR/cddbchoices"
1433 UNKNOWNDISK=y
1434 for TRACK in $(f_seq_row 1 $TRACKS)
1435 do
1436 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.0" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1437 done
1438 echo >> "$ABCDETEMPDIR/cddbchoices"
1439 echo cddb-read-0-complete >> "$ABCDETEMPDIR/status"
1440 echo cddb-choice=0 >> "$ABCDETEMPDIR/status"
1441 ;;
1442 210|211)
1443 # Multiple exact, (possibly multiple) inexact matches
1444 IN=
1445 if [ "$RESPONSECODE" = "211" ]; then IN=in; fi
1446 if [ "$(wc -l < $ABCDETEMPDIR/cddbquery | tr -d ' ')" -eq 3 ]; then
1447 echo "One ${IN}exact match:" >> "$ABCDETEMPDIR/cddbchoices"
1448 tail -n +2 "$ABCDETEMPDIR/cddbquery" | head -n 1 >> "$ABCDETEMPDIR/cddbchoices"
1449 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1450 else
1451 echo "Multiple ${IN}exact matches:" >> "$ABCDETEMPDIR/cddbchoices"
1452 fi
1453 vecho -n "Retrieving multiple matches... "
1454 grep -v ^[.]$ "$ABCDETEMPDIR/cddbquery" | ( X=0
1455 read DISCINFO # eat top line
1456 while read DISCINFO
1457 do
1458 X=$(expr $X + 1)
1459 if checkstatus cddb-read-$X-complete; then :; else
1460 $CDDBTOOL read $CDDBURL $CDDBPROTO $CDDBUSER $CDDBHOST $(echo $DISCINFO | cut -f1,2 -d' ') > "$ABCDETEMPDIR/cddbread.$X"
1461 echo cddb-read-$X-complete >> "$ABCDETEMPDIR/status"
1462 fi
1463 # List out disc title/author and contents
1464 echo \#$X: ---- "$DISCINFO" ---- >> "$ABCDETEMPDIR/cddbchoices"
1465 for TRACK in $(f_seq_row 1 $TRACKS)
1466 do
1467 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.$X" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1468 done
1469 echo >> "$ABCDETEMPDIR/cddbchoices"
1470 done )
1471 vecho "done."
1472 CDDBCHOICES=$(expr $(cat "$ABCDETEMPDIR/cddbquery" | wc -l) - 2)
1473 ;;
1474 999)
1475 # Using local copy.
1476 for TRACK in $(f_seq_row 1 $TRACKS)
1477 do
1478 echo $TRACK: "$(grep ^TTITLE$(expr $TRACK - 1)= "$ABCDETEMPDIR/cddbread.1" | cut -f2- -d= | tr -d \\r\\n)" >> "$ABCDETEMPDIR/cddbchoices"
1479 done
1480 echo >> "$ABCDETEMPDIR/cddbchoices"
1481 echo cddb-read-1-complete >> "$ABCDETEMPDIR/status"
1482 echo cddb-choice=1 >> "$ABCDETEMPDIR/status"
1483 ;;
1484 esac
1485 echo "cddb-readcomplete" >> "$ABCDETEMPDIR/status"
1486 fi
1487 }
1488
1489 # do_cddbedit
1490 do_cddbedit ()
1491 {
1492 if checkstatus cddb-edit >/dev/null; then
1493 CDDBDATA="$ABCDETEMPDIR/cddbread.$(checkstatus cddb-choice)"
1494 VARIOUSARTISTS="$(checkstatus variousartists)"
1495 VARIOUSARTISTSTYLE="$(checkstatus variousartiststyle)"
1496 return 0
1497 fi
1498 if [ "$INTERACTIVE" = "y" ]; then
1499 # We should show the CDDB results both when we are not using the local CDDB repo
1500 # or when we are using it but we could not find a proper match
1501 if [ "$CDDBUSELOCAL" = "y" ] && [ ! "$CDDBLOCALSUCCESS" = "y" ] || [ ! "$CDDBUSELOCAL" = "y" ]; then
1502 # Display the $ABCDETEMPDIR/cddbchoices file created above
1503 # Pick a pager so that if the tracks overflow the screen the user can still view everything
1504 if [ -r "$ABCDETEMPDIR/cddbchoices" ]; then
1505 CDDBCHOICES=$(expr $(cat "$ABCDETEMPDIR/cddbquery" | wc -l) - 2)
1506 CHOICE=$(checkstatus cddb-choice)
1507 if [ -n "$CHOICE" ] ; then
1508 case $CDDBCHOICES in
1509 1) cat "$ABCDETEMPDIR/cddbchoices" ;;
1510 *)
1511 echo "Selected: #$CHOICE"
1512 do_cddbparse "$ABCDETEMPDIR/cddbread.$CHOICE"
1513 ;;
1514 esac
1515 else
1516 # The user has a choice to make, display the info in a pager if necessary
1517 if [ $(cat "$ABCDETEMPDIR/cddbchoices" | wc -l) -ge 24 ]; then
1518 # Use the debian sensible-pager wrapper to pick the pager
1519 # user has requested via their $PAGER environment variable
1520 if [ -x "/usr/bin/sensible-pager" ]; then
1521 /usr/bin/sensible-pager "$ABCDETEMPDIR/cddbchoices"
1522 elif [ -x "$PAGER" ]; then
1523 # That failed, try to load the preferred editor, starting
1524 # with their PAGER variable
1525 $PAGER "$ABCDETEMPDIR/cddbchoices"
1526 # If that fails, check for less
1527 elif [ -x /usr/bin/less ]; then
1528 /usr/bin/less -f "$ABCDETEMPDIR/cddbchoices"
1529 # more should be on all UNIX systems
1530 elif [ -x /bin/more ]; then
1531 /bin/more "$ABCDETEMPDIR/cddbchoices"
1532 else
1533 # No bananas, just cat the thing
1534 cat "$ABCDETEMPDIR/cddbchoices" >&2
1535 fi
1536 else
1537 # It's all going to fit in one page, cat it
1538 cat "$ABCDETEMPDIR/cddbchoices" >&2
1539 fi
1540
1541 # I'll take CDDB read #3 for $400, Alex
1542 echo -n "Which entry would you like abcde to use (0 for none)? [0-$CDDBCHOICES]: " >&2
1543 read CDDBCHOICE
1544 [ X"$CDDBCHOICE" = "X" ] && CDDBCHOICE=1
1545 # Make sure we get a valid choice
1546 CDCHOICENUM=$(echo $CDDBCHOICE | xargs printf %d 2>/dev/null)
1547 while [ $CDCHOICENUM -lt 0 ] || [ $CDCHOICENUM -gt $CDDBCHOICES ]; do
1548 echo "Invalid selection. Please choose a number between 1 and $CDDBCHOICES." >&2
1549 echo -n "Selection [0-$CDDBCHOICES]: " >&2
1550 read CDDBCHOICE
1551 CDCHOICENUM=$(echo $CDDBCHOICE | xargs printf %d 2>/dev/null)
1552 done
1553 if [ "$CDCHOICENUM" = "0" ]; then
1554 vecho "Creating empty CDDB template..."
1555 UNKNOWNDISK=y
1556 $CDDBTOOL template $(cat "$ABCDETEMPDIR/discid") > $ABCDETEMPDIR/cddbread.0
1557 else
1558 echo "Selected: #$CDCHOICENUM ($(grep ^DTITLE= $ABCDETEMPDIR/cddbread.$CDCHOICENUM | cut -f2- -d= | tr -d \\r\\n))" >&2
1559 do_cddbparse "$ABCDETEMPDIR/cddbread.$CDCHOICENUM"
1560 fi
1561 echo "cddb-choice=$CDCHOICENUM" >> "$ABCDETEMPDIR/status"
1562 fi
1563 fi
1564 else
1565 # We need some code to show the selected option when local repository is selected and we have found a match
1566 vecho "Using cached CDDB match..." >&2
1567 # Display the $ABCDETEMPDIR/cddbchoices file created above
1568 # Pick a pager so that if the tracks overflow the screen the user can still view everything
1569 if [ -r "$ABCDETEMPDIR/cddbchoices" ]; then
1570 CDDBCHOICES=$(expr $(cat "$ABCDETEMPDIR/cddbquery" | wc -l) - 2)
1571 CHOICE=$(checkstatus cddb-choice)
1572 if [ "$USELOCALRESP" = "y" ]; then :; else
1573 if [ -n "$CHOICE" ] ; then
1574 case $CDDBCHOICES in
1575 0)
1576 UNKNOWNDISK=y
1577 echo "Selected template."
1578 ;;
1579 1) cat "$ABCDETEMPDIR/cddbchoices" ;;
1580 *)
1581 echo "Selected: #$CHOICE"
1582 do_cddbparse "$ABCDETEMPDIR/cddbread.$CHOICE"
1583 ;;
1584 esac
1585 fi
1586 fi
1587 fi
1588 fi
1589 else
1590 # We're noninteractive - pick the first choice.
1591 # But in case we run a previous instance and selected a choice, use it.
1592 if [ -r "$ABCDETEMPDIR/cddbchoices" ]; then
1593 # Show the choice if we are not using the locally stored one
1594 # or when the local search failed to find a match.
1595 PREVIOUSCHOICE=$(checkstatus cddb-choice)
1596 if [ "$CDDBUSELOCAL" = "y" ] && [ "$CDDBLOCALSUCCESS" = "n" ] || [ ! "$CDDBUSELOCAL" = "y" ]; then
1597 #if [ "$PREVIOUSCHOICE" ]; then
1598 cat "$ABCDETEMPDIR/cddbchoices"
1599 #fi
1600 fi
1601 if [ ! -z "$PREVIOUSCHOICE" ] ; then
1602 CDCHOICENUM=$PREVIOUSCHOICE
1603 else
1604 CDCHOICENUM=1
1605 echo "cddb-choice=$CDCHOICENUM" >> "$ABCDETEMPDIR/status"
1606 fi
1607 echo "Selected: #$CDCHOICENUM ($(grep ^DTITLE= $ABCDETEMPDIR/cddbread.$CDCHOICENUM | cut -f2- -d= | tr -d \\r\\n))" >&2
1608 fi
1609 fi
1610
1611 # sanity check
1612 if checkstatus cddb-choice >/dev/null; then :; else
1613 echo "abcde: internal error: cddb-choice not recorded." >&2
1614 exit 1
1615 fi
1616 CDDBDATA="$ABCDETEMPDIR/cddbread.$(checkstatus cddb-choice)"
1617 echo -n "Edit selected CDDB data? [y/n] (" >&2
1618 if [ "$INTERACTIVE" = "y" ]; then
1619 if [ "$UNKNOWNDISK" = "y" ]; then
1620 echo -n "y): " >&2
1621 read EDITCDDB
1622 [ "$EDITCDDB" != "n" ] && EDITCDDB=y
1623 else
1624 echo -n "n): " >&2
1625 read EDITCDDB
1626 fi
1627 else
1628 echo "n): n" >&2
1629 EDITCDDB=n
1630 fi
1631 if [ "$EDITCDDB" = "y" ]; then
1632 CDDBDATAMD5SUM=$($MD5SUM "$CDDBDATA" | cut -d " " -f 1);
1633
1634 # Use the debian sensible-editor wrapper to pick the editor that the
1635 # user has requested via their $EDITOR environment variable
1636 if [ -x "/usr/bin/sensible-editor" ]; then
1637 /usr/bin/sensible-editor "$CDDBDATA"
1638 elif [ -n "$EDITOR" ]; then
1639 if [ -x $(which "${EDITOR%%\ *}") ]; then
1640 # That failed, try to load the preferred editor, starting
1641 # with their EDITOR variable
1642 eval $(echo "$EDITOR") "$CDDBDATA"
1643 fi
1644 # If that fails, check for a vi
1645 elif which vi >/dev/null 2>&1; then
1646 vi "$CDDBDATA"
1647 elif [ -x /usr/bin/vi ]; then
1648 /usr/bin/vi "$CDDBDATA"
1649 # nano should be on all (modern, i.e., sarge) debian systems
1650 elif which nano >/dev/null 2>&1 ; then
1651 nano "$CDDBDATA"
1652 elif [ -x /usr/bin/nano ]; then
1653 /usr/bin/nano "$CDDBDATA"
1654 # mg should be on all OpenBSD systems
1655 elif which mg >/dev/null 2>&1 ; then
1656 mg "$CDDBDATA"
1657 elif [ -x /usr/bin/mg ]; then
1658 /usr/bin/mg "$CDDBDATA"
1659 # bomb out
1660 else
1661 echo "No editor available. Check your EDITOR environment variable." >&2
1662 fi
1663 # delete editor backup file if it exists
1664 if [ -w "$CDDBDATA~" ]; then
1665 rm -f "$CDDBDATA~"
1666 fi
1667 fi
1668
1669 # Some heuristics first. Look at Disc Title, and if it starts with
1670 # "Various", then we'll assume Various Artists
1671 if [ "$(grep ^DTITLE= "$CDDBDATA" | cut -f2- -d= | egrep -ci '^(various|soundtrack|varios|sonora|ost)')" != "0" ]; then
1672 echo "Looks like a Multi-Artist CD" >&2
1673 VARIOUSARTISTS=y
1674 else
1675 echo -n "Is the CD multi-artist? [y/n] (n): " >&2
1676 if [ "$INTERACTIVE" = "y" ]; then
1677 read VARIOUSARTISTS
1678 else
1679 echo n >&2
1680 VARIOUSARTISTS=n
1681 fi
1682 fi
1683 if [ "$VARIOUSARTISTS" = "y" ] && [ ! "$ONETRACK" = "y" ]; then
1684 # Set a default
1685 DEFAULTSTYLE=1
1686 # Need NUMTRACKS before cddb-tool will return it:
1687 NUMTRACKS=$(egrep '^TTITLE[0-9]+=' "$CDDBDATA" | wc -l)
1688 if [ "$(grep -c "^TTITLE.*\/" "$CDDBDATA")" -gt "$(expr $NUMTRACKS / 2 )" ]; then
1689 # More than 1/2 tracks contain a "/", so guess forward
1690 DEFAULTSTYLE=1
1691 elif [ "$(grep -c "^TTITLE.*\-" "$CDDBDATA")" -gt "$(expr $NUMTRACKS / 2 )" ]; then
1692 # More than 1/2 contain a "-", so guess forward-dash
1693 DEFAULTSTYLE=2
1694 elif [ "$(grep -c "^TTITLE.*(.*)" "$CDDBDATA")" -gt "$(expr $NUMTRACKS / 2 )" ]; then
1695 # More than 1/2 contain something in parens, so guess trailing-paren
1696 DEFAULTSTYLE=6
1697 fi
1698
1699 echo "1) Artist / Title" >&2
1700 echo "2) Artist - Title" >&2
1701 echo "3) Title / Artist" >&2
1702 echo "4) Title - Artist" >&2
1703 echo "5) Artist: Title" >&2
1704 echo "6) Title (Artist)" >&2
1705 echo "7) This is a single-artist CD" >&2
1706 echo -n "Which style of multiple artist entries is it? [1-7] ($DEFAULTSTYLE): " >&2
1707 if [ "$INTERACTIVE" = "y" ]; then
1708 read VARIOUSARTISTSTYLE
1709 else
1710 echo $DEFAULTSTYLE >&2
1711 VARIOUSARTISTSTYLE=$DEFAULTSTYLE
1712 fi
1713 VARIOUSARTISTSTYLE=$(echo 0$VARIOUSARTISTSTYLE | xargs printf %d)
1714 # If they press Enter, then the default style (0) was chosen
1715 while [ $VARIOUSARTISTSTYLE -lt 0 ] || [ $VARIOUSARTISTSTYLE -gt 7 ]; do
1716 echo "Invalid selection. Please choose a number between 1 and 7."
1717 echo -n "Selection [1-7]: "
1718 read VARIOUSARTISTSTYLE
1719 VARIOUSARTISTSTYLE=$(echo 0$VARIOUSARTISTSTYLE | xargs printf %d)
1720 done
1721 if [ "$VARIOUSARTISTSTYLE" = "0" ]; then
1722 VARIOUSARTISTSTYLE=$DEFAULTSTYLE
1723 fi
1724 vecho "Selected: $VARIOUSARTISTSTYLE"
1725 case "$VARIOUSARTISTSTYLE" in
1726 1) # Artist / Title
1727 VARIOUSARTISTSTYLE=forward
1728 ;;
1729 2) # Artist - Title
1730 VARIOUSARTISTSTYLE=forward-dash
1731 ;;
1732 3) # Title / Artist
1733 VARIOUSARTISTSTYLE=reverse
1734 ;;
1735 4) # Title - Artist
1736 VARIOUSARTISTSTYLE=reverse-dash
1737 ;;
1738 5) # Artist: Title
1739 VARIOUSARTISTSTYLE=colon
1740 ;;
1741 6) # Title (Artist)
1742 VARIOUSARTISTSTYLE=trailing-paren
1743 ;;
1744 7) # Single Artist
1745 VARIOUSARTISTS=n
1746 ;;
1747 esac
1748 fi
1749
1750 echo "variousartists=$VARIOUSARTISTS" >> "$ABCDETEMPDIR/status"
1751 echo "variousartiststyle=$VARIOUSARTISTSTYLE" >> "$ABCDETEMPDIR/status"
1752
1753 if [ "$EDITCDDB" = "y" ] && [ "$UNINTENTIONALLY_ANGER_THE_FREEDB_PEOPLE" = "y" ]; then
1754 if [ $CDDBDATAMD5SUM != "" ] && [ $CDDBDATAMD5SUM != $($MD5SUM "$CDDBDATA" | cut -d " " -f 1) ]; then
1755 # This works but does not have the necessary error checking
1756 # yet. If you are familiar with the CDDB spec
1757 # (see http://www.freedb.org/src/latest/DBFORMAT)
1758 # and can create an error-free entry on your own, then put
1759 # UNINTENTIONALLY_ANGER_THE_FREEDB_PEOPLE=y in your
1760 # abcde.conf to enable it. Put CDDBSUBMIT=email@address in
1761 # your abcde.conf to change the email address submissions are
1762 # sent to.
1763
1764 # submit the modified file, if they want
1765 if [ "$NOSUBMIT" != "y" ]; then
1766 echo -n "Do you want to submit this entry to $CDDBSUBMIT? [y/n] (n): "
1767 read YESNO
1768 while [ "$YESNO" != "y" ] && [ "$YESNO" != "n" ] && [ "$YESNO" != "Y" ] && \
1769 [ "$YESNO" != "N" ] && [ "$YESNO" != "" ]
1770 do
1771 echo -n 'Invalid selection. Please answer "y" or "n": '
1772 read YESNO
1773 done
1774 if [ "$YESNO" = "y" ] || [ "$YESNO" = "Y" ]; then
1775 echo -n "Sending..."
1776 $CDDBTOOL send "$CDDBDATA" $CDDBSUBMIT
1777 echo "done."
1778 fi
1779 fi
1780 fi
1781 fi
1782 # Make sure the cache directory exists
1783 mkdir -p $CDDBLOCALDIR
1784 # Cache edited CDDB entry in the user's cddb dir
1785 if [ "$CDDBCOPYLOCAL" = "y" ] || [ "$COPYCDDBLOCAL" = "Y" ]; then
1786 cat "$CDDBDATA" | tail -n $(expr $(cat "$CDDBDATA" | wc -l ) - 1 ) > ${CDDBLOCALDIR}/$(echo "$TRACKINFO" | cut -d' ' -f1)
1787 fi
1788
1789 echo "cddb-edit" >> "$ABCDETEMPDIR/status"
1790 }
1791
1792 # do_cdread [tracknumber]
1793 # do_cdread onetrack [firsttrack] [lasttrack]
1794 #
1795 do_cdread ()
1796 {
1797 # The commands here don't go through run_command because they're never supposed to be silenced
1798 # return codes need to be doublechecked anyway, however
1799 if [ "$1" = "onetrack" ]; then
1800 # FIXME # Add the possibility of grabbing ranges of tracks in onetrack
1801 # FIXME # Until then, we grab the whole CD in one track, no matter what
1802 # the user said
1803 # We need the first and last track for cdda2wav
1804 FIRSTTRACK=$2
1805 LASTTRACK=$3
1806 UTRACKNUM=$FIRSTTRACK
1807 case "$CDROMREADERSYNTAX" in
1808 cdparanoia) READTRACKNUMS="$FIRSTTRACK-$LASTTRACK" ;;
1809 cdda2wav) READTRACKNUMS="$FIRSTTRACK+$LASTRACK" ;;
1810 *) echo "abcde error: $CDROMREADERSYNTAX does not support ONETRACK mode"
1811 exit 1 ;;
1812 esac
1813 else
1814 UTRACKNUM=$1
1815 fi
1816 CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
1817 if [ "$USEPIPES" = "y" ]; then
1818 TEMPARG="PIPE_$CDROMREADERSYNTAX"
1819 FILEARG=${!TEMPARG}
1820 REDIR=""
1821 PIPE_MESSAGE="and encoding "
1822 else
1823 WAVDATA="$ABCDETEMPDIR/track$UTRACKNUM.wav"
1824 case "$CDROMREADERSYNTAX" in
1825 ## FIXME ## Find the case for dagrab, to avoid exceptions
1826 dagrab)
1827 FILEARG="-f $WAVDATA"
1828 ;;
1829 *)
1830 FILEARG=$WAVDATA
1831 ;;
1832 esac
1833 REDIR=">&2"
1834 fi
1835 if [ "$1" = "onetrack" ]; then
1836 echo "Grabbing ${PIPE_MESSAGE}tracks $UTRACKNUM - $LASTTRACK ..." >&2
1837 else
1838 if [ -r "$CDDBDATA" ]; then
1839 TRACKNAME=$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | head -n 1 | cut -f2 -d= | tr -d \[:cntrl:\])
1840 echo "Grabbing ${PIPE_MESSAGE}track $UTRACKNUM: $TRACKNAME..." >&2
1841 else
1842 echo "Grabbing ${PIPE_MESSAGE}track $UTRACKNUM..." >&2
1843 fi
1844 fi
1845 case "$CDROMREADERSYNTAX" in
1846 cdparanoia)
1847 nice $READNICE $CDROMREADER -d $CDROM ${READTRACKNUMS:-$UTRACKNUM} $FILEARG $REDIR ;;
1848 cdda2wav)
1849 if [ "$OSFLAVOUR" = "OSX" ] ; then
1850 # Hei, we have to unmount the device before running anything like cdda2wav in OSX
1851 disktool -u ${CDROM#/dev/} 0
1852 # Also, in OSX the cdrom device for cdda2wav changes...
1853 CDDA2WAVCDROM="IODVDServices"
1854 elif [ "$OSFLAVOUR" = "FBSD" ] ; then
1855 CDDA2WAVCDROM="$CDROMID"
1856 else
1857 if [ "$CDROMID" = "" ]; then
1858 CDDA2WAVCDROM="$CDROM"
1859 else
1860 CDDA2WAVCDROM="$CDROMID"
1861 fi
1862 fi
1863 nice $READNICE $CDROMREADER -D $CDDA2WAVCDROM -t ${READTRACKNUMS:-$UTRACKNUM} $FILEARG $REDIR
1864 ;;
1865 ## FIXME ## We have an exception for dagrab, since it uses -f
1866 ## FIXME ## Shall we just use -f $FILEARG ??
1867 dagrab) nice $READNICE $CDROMREADER -d $CDROM -v $UTRACKNUM $FILEARG $REDIR
1868 ;;
1869 cddafs)
1870 # Find the track's mounted path
1871 REALTRACKNUM=$(expr $UTRACKNUM + 0)
1872 FILEPATH=$(mount | grep "$CDROM on" | sed 's/^[^ ]* on \(.*\) (.*/\1/')
1873 FILEPATH=$(find "$FILEPATH" | grep "/$REALTRACKNUM ");
1874 # If the file exists, copy it
1875 if [ -e "$FILEPATH" ] ; then
1876 nice $READNICE $CDROMREADER "$FILEPATH" $FILEARG $REDIR
1877 else
1878 false
1879 fi ;;
1880 debug) nice $READNICE $CDROMREADER -d $CDROM -w $UTRACKNUM-[:1] $FILEARG $REDIR
1881 ;;
1882 esac
1883 RETURN=$?
1884 # If we get some error or we get some missing wav
1885 # (as long as we dont use pipes)
1886 if [ "$RETURN" != "0" -o \( ! -s "$WAVDATA" -a X"$USEPIPES" != "Xy" \) ]; then
1887 # Thank goodness errors is only machine-parseable up to the
1888 # first colon, otherwise this woulda sucked
1889 if [ "$RETURN" = "0" -a ! -s "$WAVDATA" ]; then
1890 RETURN=73 # fake a return code as cdparanoia return 0 also on aborted reads
1891 fi
1892 if [ "$USEPIPES" = "y" ]; then
1893 echo "readencodetrack-$UTRACKNUM: $CDROMREADER returned code $RETURN" >> "$ABCDETEMPDIR/errors"
1894 else
1895 echo "readtrack-$UTRACKNUM: $CDROMREADER returned code $RETURN" >> "$ABCDETEMPDIR/errors"
1896 fi
1897 return $RETURN
1898 else
1899 if [ "$USEPIPES" = "y" ]; then
1900 echo readencodetrack-$UTRACKNUM >> "$ABCDETEMPDIR/status"
1901 else
1902 echo readtrack-$UTRACKNUM >> "$ABCDETEMPDIR/status"
1903 fi
1904 fi
1905 }
1906
1907 # do_cdspeed
1908 # No values accepted, only uses env variables
1909 do_cdspeed ()
1910 {
1911 if "$CDSPEED" "$CDSPEEDOPTS" "$CDSPEEDVALUE" >/dev/null ; then
1912 vecho "Setting CD speed to ${CDSPEEDVALUE}x"
1913 else
1914 echo "abcde: unable to set the device speed" >&2
1915 fi
1916 }
1917
1918 # vecho [message]
1919 #
1920 # vecho outputs a message if EXTRAVERBOSE is selected
1921 vecho ()
1922 {
1923 if [ x"$EXTRAVERBOSE" != "x" ]; then
1924 echo $@
1925 fi
1926 }
1927
1928 # User-redefinable functions
1929 # Custom filename munging:
1930 mungefilename ()
1931 {
1932 #echo "$@" | sed s,:,\ -,g | tr \ /\* __+ | tr -d \'\"\?\[:cntrl:\]
1933 echo "$@" | sed s,:,\ -,g | tr \ / __ | tr -d \'\"\?\[:cntrl:\]
1934 }
1935
1936 # Custom genre munging:
1937 mungegenre ()
1938 {
1939 echo $CDGENRE | tr "[:upper:]" "[:lower:]"
1940 }
1941
1942 # pre_read
1943 # Empty pre_read function, to be defined in the configuration file.
1944 pre_read ()
1945 {
1946 :
1947 }
1948
1949 # do_movecue
1950 # Standalone function to move the CUE file to the final location
1951
1952 ###############################################################################
1953 # End of functions
1954 #
1955 # Start of execution
1956 ###############################################################################
1957
1958 # Builtin defaults
1959 CDDBURL="http://freedb.freedb.org/~cddb/cddb.cgi"
1960 CDDBSUBMIT=freedb-submit@freedb.org
1961 CDDBPROTO=5
1962 HELLOINFO="$(whoami)@$(hostname)"
1963 INTERACTIVE=y
1964 CDROMREADERSYNTAX=cdparanoia
1965 OUTPUTTYPE=ogg
1966 ENCODERSYNTAX=default
1967
1968 MP3ENCODERSYNTAX=default
1969 OGGENCODERSYNTAX=default
1970 FLACENCODERSYNTAX=default
1971 SPEEXENCODERSYNTAX=default
1972 MPPENCODERSYNTAX=default
1973 NORMALIZERSYNTAX=default
1974
1975 OUTPUTFORMAT='${ARTISTFILE}-${ALBUMFILE}/${TRACKNUM}.${TRACKFILE}'
1976 # Use the following VAOUTPUTFORMAT to revert to 2.0.x VA format:
1977 #VAOUTPUTFORMAT=${OUTPUTFORMAT}
1978 VAOUTPUTFORMAT='Various-${ALBUMFILE}/${TRACKNUM}.${ARTISTFILE}-${TRACKFILE}'
1979 ONETRACKOUTPUTFORMAT='${ARTISTFILE}-${ALBUMFILE}/${ALBUMFILE}'
1980 VAONETRACKOUTPUTFORMAT='Various-${ALBUMFILE}/${ALBUMFILE}'
1981 PLAYLISTFORMAT='${ARTISTFILE}-${ALBUMFILE}.${OUTPUT}.m3u'
1982 PLAYLISTDATAPREFIX=''
1983 VAPLAYLISTFORMAT='${ARTISTFILE}-${ALBUMFILE}.${OUTPUT}.m3u'
1984 VAPLAYLISTDATAPREFIX=''
1985 DOSPLAYLIST=n
1986 COMMENT=''
1987 ID3TAGV=2
1988 ENCNICE=10
1989 READNICE=10
1990 DISTMP3NICE=10
1991 VARIOUSARTISTS=n
1992 VARIOUSARTISTSTYLE=forward
1993 KEEPWAVS=n
1994 PADTRACKS=n
1995 CDDBCOPYLOCAL="n"
1996 CDDBLOCALDIR="$HOME/.cddb"
1997 CDDBUSELOCAL="n"
1998
1999 # If using scsi devices, cdda2wav needs a CDROMID, instead of a device node
2000 # i.e. CDROMID="1,0,0"
2001 CDROMID=""
2002
2003 # program paths - defaults to checking your $PATH
2004 # mp3
2005 LAME=lame
2006 GOGO=gogo
2007 BLADEENC=bladeenc
2008 L3ENC=l3enc
2009 XINGMP3ENC=xingmp3enc
2010 MP3ENC=mp3enc
2011 # ogg
2012 VORBIZE=vorbize
2013 OGGENC=oggenc
2014 # flac
2015 FLAC=flac
2016 # speex
2017 SPEEXENC=speexenc
2018 # mpp (Musepack)
2019 MPPENC=mppenc
2020
2021 ID3=id3
2022 ID3V2=id3v2
2023 CDPARANOIA=cdparanoia
2024 CDDA2WAV=cdda2wav
2025 DAGRAB=dagrab
2026 CDDAFS=cp
2027 CDDISCID=cd-discid
2028 CDDBTOOL=cddb-tool
2029 EJECT=eject
2030 MD5SUM=md5sum
2031 DISTMP3=distmp3
2032 VORBISCOMMENT=vorbiscomment
2033 METAFLAC=metaflac
2034 NORMALIZE=normalize-audio
2035 CDSPEED=eject
2036 VORBISGAIN=vorbisgain
2037 MKCUE=mkcue
2038
2039 # Options for programs called from abcde
2040 # mp3
2041 LAMEOPTS=
2042 GOGOOPTS=
2043 BLADEENCOPTS=
2044 L3ENCOPTS=
2045 XINGMP3ENCOPTS=
2046 MP3ENCOPTS=
2047 # ogg
2048 VORBIZEOPTS=
2049 OGGENCOPTS=
2050 # flac
2051 FLACOPTS=
2052 # speex
2053 SPEEXENCOPTS=
2054 # mpc
2055 MPPENCOPTS=
2056
2057 ID3OPTS=
2058 ID3V2OPTS=
2059 CDPARANOIAOPTS=
2060 CDDA2WAVOPTS=
2061 DAGRABOPTS=
2062 CDDAFSOPTS="-f"
2063 CDDBTOOLOPTS=
2064 EJECTOPTS=
2065 DISTMP3OPTS=
2066 NORMALIZEOPTS=
2067 CDSPEEDOPTS="-x"
2068 CDSPEEDVALUE=
2069 MKCUEOPTS=
2070 VORBISCOMMENTOPTS="-R"
2071 METAFLACOPTS="--no-utf8-convert"
2072
2073 # Default to one process if -j isn't specified
2074 MAXPROCS=1
2075
2076 # List of actions to perform - by default, run to completion
2077 ACTIONS=cddb,read,encode,tag,move,clean
2078
2079 # Asume fetch if under FreeBSD. curl is used for Mac OS X. wget is used for Linux/OpenBSD/NetBSD.
2080 # Let's use these checkings to determine the OS flavour, which will be used later
2081 if [ X$(uname) = "XFreeBSD" ] ; then
2082 HTTPGET=fetch
2083 NEEDCDROMID=y
2084 OSFLAVOUR=FBSD
2085 elif [ X$(uname) = "XDarwin" ] ; then
2086 HTTPGET=curl
2087 OSFLAVOUR=OSX
2088 # We should have disktool in OSX, but let's be sure...
2089 NEEDDISKTOOL=y
2090 CDROMREADERSYNTAX=cddafs
2091 elif [ X$(uname) = "XOpenBSD" ] ; then
2092 HTTPGET=wget
2093 MD5SUM=md5
2094 else
2095 HTTPGET=wget
2096 fi
2097
2098 # If CDDBAVAIL is set to n, no CDDB read is done
2099 # If USEID3 is set to n, no ID3 tagging is done
2100 CDDBAVAIL=y
2101 USEID3=y
2102 USEID3V2=y
2103
2104 if [ -z "$OUTPUTDIR" ]; then
2105 OUTPUTDIR=$(pwd)
2106 fi
2107
2108 if [ -z "$WAVOUTPUTDIR" ]; then
2109 WAVOUTPUTDIR="$OUTPUTDIR"
2110 fi
2111
2112 # Load system defaults
2113 if [ -r /etc/abcde.conf ]; then
2114 . /etc/abcde.conf
2115 fi
2116 # Load user preference defaults
2117 if [ -r $HOME/.abcde.conf ]; then
2118 . $HOME/.abcde.conf
2119 fi
2120
2121 # By this time, we need some HTTPGETOPTS already defined.
2122 # If the user has defined a non-default HTTPGET method, we should not be empty.
2123
2124 if [ "$HTTPGETOPTS" = "" ] ; then
2125 case $HTTPGET in
2126 wget) HTTPGETOPTS="-q -O -";;
2127 curl) HTTPGETOPTS="-f -s";;
2128 fetch)HTTPGETOPTS="-q -o -";;
2129 *) echo "abcde warning: HTTPGET in non-standard and HTTPGETOPTS are not defined." >&2 ;;
2130 esac
2131 fi
2132
2133 # If the CDROM has not been set yet, find a suitable one.
2134 # If this is a devfs system, default to /dev/cdroms/cdrom0
2135 # instead of /dev/cdrom
2136 if [ "$CDROM" = "" ] ; then
2137 if [ -e /dev/cdroms/cdrom0 ]; then
2138 CDROM=/dev/cdroms/cdrom0
2139 elif [ -e /dev/cdrom ]; then
2140 CDROM=/dev/cdrom
2141 elif [ -e /dev/cd0c ]; then
2142 CDROM=/dev/cd0c
2143 elif [ -e /dev/acd0c ]; then
2144 CDROM=/dev/acd0c
2145 elif [ -e /dev/disk1 ]; then
2146 CDROM=/dev/disk1
2147 fi
2148 fi
2149
2150 # Parse command line options
2151 #while getopts 1a:bc:C:d:Dhj:klLnNo:pr:S:t:T:vVx opt ; do
2152 while getopts 1a:A:bc:C:d:Dehj:klLmMnNo:pPr:Rs:S:t:T:vVxw:W: opt ; do
2153 case "$opt" in
2154 1) ONETRACK=y ;;
2155 a) ACTIONS="$OPTARG" ;;
2156 A) EXPACTIONS="$OPTARG";;
2157 b) BATCH=y ;;
2158 c) if [ -e "$OPTARG" ] ; then . "$OPTARG" ; else echo "abcde error: config file \"$OPTARG\" cannot be found." >&2 ; exit 1 ; fi ;;
2159 C) DISCID="${OPTARG#abcde.}" ;;
2160 d) CDROM="$OPTARG" ;;
2161 D) set -x ;;
2162 e) ERASEENCODEDSTATUS=y ;;
2163 h) usage; exit ;;
2164 e) ERASEENCODEDSTATUS=y ;;
2165 # f) FORCECDDBUSELOCAL=y ;;
2166 i) INLINETAG=y ;;
2167 j) MAXPROCS="$OPTARG" ;;
2168 k) KEEPWAVS=y ;;
2169 l) LOWDISK=y ;;
2170 L) CDDBUSELOCAL=y ;;
2171 n) CDDBAVAIL=n ;;
2172 N) INTERACTIVE=n ;;
2173 m) DOSPLAYLIST=y ;;
2174 M) CUEFILE=y ;;
2175 o) OUTPUTTYPE="$OPTARG" ;;
2176 p) PADTRACKS=y ;;
2177 P) USEPIPES=y ;;
2178 r) REMOTEHOSTS="$OPTARG" ;;
2179 R) REPLAYGAIN=y ;;
2180 s) STARTTRACKNUMBER="$OPTARG" ;;
2181 S) CDSPEEDVALUE="$OPTARG" ;;
2182 # t) PREPROCESSFORMATS="$OPTARG"
2183 # PREPROCESS=y ;;
2184 # T) POSTPROCESSFORMATS="$OPTARG" ;;
2185 t) STARTTRACKNUMBER="$OPTARG" ;;
2186 T) STARTTRACKNUMBER="$OPTARG" ; STARTTRACKNUMBERTAG="y" ;;
2187 v)
2188 echo "This is abcde v$VERSION."
2189 echo "Usage: abcde [options] [tracks]"
2190 echo "abcde -h for extra help"
2191 exit
2192 ;;
2193 V) EXTRAVERBOSE="y" ;;
2194 x) EJECTCD="y" ;;
2195 w) COMMENT="$OPTARG" ;;
2196 W) if echo $OPTARG | grep -q "[[:digit:]]" ; then
2197 STARTTRACKNUMBER="${OPTARG}01" ; STARTTRACKNUMBERTAG="y" ; COMMENT="CD${OPTARG}"
2198 else
2199 echo "abcde error: argument of -W must be integer"
2200 exit 1
2201 fi
2202 ;;
2203 ?) usage; exit ;;
2204 esac
2205 done
2206
2207 shift $(($OPTIND - 1))
2208
2209 # Decide if we can continue.
2210 if [ "$ONETRACK" = "y" ]; then
2211 # FIXME # remove check as soon as we find out about the other readers
2212 case "$CDROMREADERSYNTAX" in
2213 dagrab|cddafs|debug) echo "abcde error: ONETRACK reading is not suported with $CDROMREADERSYNTAX yet"
2214 exit 1 ;;
2215 esac
2216 if [ "$BATCH" = "y" ]; then
2217 echo "abcde error: BATCH mode is not compatible with ONETRACK mode"
2218 BATCH=n
2219 fi
2220 # It does not matter how many tracks we want. In ONETRACK mode we grab them all
2221 # FIXME # allow ranges of tracks to be selected for onetrack ripping
2222 if [ $# -gt 0 ]; then
2223 vecho "abcde warning: ONETRACK mode selected, grabbing all tracks..."
2224 fi
2225 else
2226 while [ $# -gt 0 ]; do
2227 # Range parsing code courtesy of Vincent Ho
2228 RSTART=$(echo $1 | cut -f1 -d-)
2229 REND=$(echo $1 | cut -f2 -d-)
2230 if [ "$RSTART" = "$REND" ]; then
2231 NEWTRACKS="$RSTART"
2232 else
2233 NEWTRACKS=$(f_seq_line $RSTART $REND)
2234 fi
2235 TRACKQUEUE=$(echo "$TRACKQUEUE" "$NEWTRACKS")
2236 shift
2237 done
2238 fi
2239
2240 # List of valid actions: cddb,read,normalize,encode,tag,move,playlist,clean
2241 # List of experimental actions: retag,transcode
2242
2243 # Determine what actions are to be done from $ACTIONS and set the
2244 # following environment variables for them:
2245 DOCDDB=n
2246 DOREAD=n
2247 DONORMALIZE=n
2248 DOPREPROCESS=n
2249 DOENCODE=n
2250 DOPOSTPROCESS=n
2251 DOTAG=n
2252 DOMOVE=n
2253 DOPLAYLIST=n
2254 DOCLEAN=n
2255
2256 for ACTION in $(echo $ACTIONS | tr , \ )
2257 do
2258 case $ACTION in
2259 cddb) DOCDDB=y;;
2260 read) DOREAD=y;;
2261 normalize) DONORMALIZE=y; DOREAD=y;;
2262 # preprocess) DOPREPROCESS=y; DOREAD=y;;
2263 encode) DOENCODE=y; DOREAD=y;;
2264 # postprocess) DOPREPROCESS=y; DOENCODE=y; DOREAD=y;;
2265 tag) DOTAG=y; DOREAD=y; DOENCODE=y; DOCDDB=y;;
2266 move) DOMOVE=y; DOTAG=y; DOREAD=y; DOENCODE=y; DOCDDB=y;;
2267 playlist) DOCDDB=y; DOPLAYLIST=y;;
2268 clean) DOCLEAN=y;;
2269 esac
2270 done
2271
2272 # Sanity checks:
2273
2274 # At this point a CDROM has to be defined, so we check it exists.
2275 if [ X"$CDROM" != "X" ] ; then
2276 if [ "$CDROMREADERSYNTAX" = "cdda2wav" ] && [ "$NEEDCDROMID" = "y" ] ; then
2277 if [ "$OSFLAVOUR" = "FBSD" ]; then
2278 if ! echo "$CDROMID" | grep "^[0-9],[0-9],[0-9]$" >/dev/null 2>&1 ; then
2279 echo "abcde error: CDROMID not in the right format for $CDROMREADERSYNTAX"
2280 echo "Use \"cdrecord -scanbus\" to obtain a adecuate ID an set CDROMID accordingly"
2281 exit 1
2282 fi
2283 fi
2284 elif [ ! -e "$CDROM" -a X"$DOREAD" = "Xy" ]; then
2285 echo "abcde error: CDROM device cannot be found." >&2
2286 exit 1
2287 fi
2288 # avoid processing if we are not going to hit the CDROM.
2289 elif [ X"$DOREAD" = "Xy" ]; then
2290 echo "abcde error: CDROM has not been defined or cannot be found" >&2
2291 exit 1
2292 fi
2293
2294 # USEPIPES pre-tests, before we get into more serious stuff
2295 # Not compatible with:
2296 # - multiple outputs
2297 # - normalize
2298 # - lowdisk algorithm
2299 # - anything else?
2300 if [ X"$USEPIPES" = "Xy" ]; then
2301 if [ $(echo $OUTPUTTYPE | tr , \ | wc -w ) -gt 1 ]; then
2302 echo "abcde error: Unix pipes not compatible with multiple outputs"
2303 exit 1
2304 fi
2305 if [ X"$DONORMALIZE" = "Xy" ]; then
2306 echo "abcde error: Unix pipes not compatible with normalizer"
2307 # FIXME # Do we need to exit or shall we just disable the mode?
2308 exit 1
2309 fi
2310 if [ X"$DOENCODE" = "Xn" ]; then
2311 vecho "Disabling Unix pipes since we are not encoding!"
2312 USEPIPES=n
2313 fi
2314 if [ X"$LOWDISK" = "Xy" ]; then
2315 vecho "abcde error: Unix pipes not compatible with lowdisk algorithm"
2316 exit 1
2317 fi
2318 fi
2319
2320 # Decide which CDROM reader we're gonna use
2321 case "$CDROMREADERSYNTAX" in
2322 cdparanoia|debug)
2323 CDROMREADER="$CDPARANOIA"
2324 CDROMREADEROPTS="$CDPARANOIAOPTS"
2325 ;;
2326 cdda2wav)
2327 CDROMREADER="$CDDA2WAV"
2328 CDROMREADEROPTS="$CDDA2WAVOPTS"
2329 ;;
2330 dagrab)
2331 CDROMREADER="$DAGRAB"
2332 CDROMREADEROPTS="$DAGRABOPTS"
2333 ;;
2334 cddafs)
2335 CDROMREADER="$CDDAFS"
2336 CDROMREADEROPTS="$CDDAFSOPTS"
2337 ;;
2338 esac
2339
2340 # There's only one normalize...
2341 case "$NORMALIZERSYNTAX" in
2342 default|normalize)
2343 NORMALIZER="$NORMALIZE"
2344 NORMALIZEROPTS="$NORMALIZEOPTS"
2345 ;;
2346 esac
2347
2348 # Allow -o OUTPUT(1):OPTIONS(1),...,OUTPUT(N):OPTIONS(N) mode of operation
2349 if echo $OUTPUTTYPE | grep ":" > /dev/null 2>&1 ; then
2350 OLDFS="$FS"
2351 export FS=","
2352 for OUTPUT in "$OUTPUTTYPE"
2353 do
2354 case "$OUTPUT" in
2355 ogg:*) OGGENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2356 mp3:*) MP3ENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2357 flac:*) FLACENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2358 spx:*) SPEEXENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2359 mpc:*) MPPENCODEROPTSCLI="$( echo $OUTPUT | cut -d: -f2- )" ;;
2360 esac
2361 done
2362 for OUTPUT in "$OUTPUTTYPE"
2363 do
2364 TEMPOUTPUT=$( echo "$OUTPUT" | cut -d: -f1 )
2365 TEMPOUTPUTTYPE="${TEMPOUTPUTTYPE:+$TEMPOUTPUTTYPE,}$TEMPOUTPUT"
2366 done
2367 OUTPUTTYPE="$TEMPOUTPUTTYPE"
2368 FS="$OLDFS"
2369 fi
2370
2371 # If nothing has been specified, use oggenc for oggs and lame for mp3s and flac for flacs and speexenc for speex and mppenc for mpps
2372
2373 # Getting ready for multiple output changes
2374 for OUTPUT in $(echo $OUTPUTTYPE | tr , \ )
2375 do
2376 case $OUTPUT in
2377 ogg) [ "$OGGENCODERSYNTAX" = "default" ] && OGGENCODERSYNTAX=oggenc
2378 [ "$DOTAG" = "y" ] && NEEDCOMMENTER=y
2379 [ "$REPLAYGAIN" = "y" ] && NEEDVORBISGAIN=y
2380 ;;
2381 mp3) [ "$MP3ENCODERSYNTAX" = "default" ] && MP3ENCODERSYNTAX=lame
2382 [ "$DOTAG" = "y" ] && NEEDTAGGER=y
2383 ;;
2384 flac) [ "$FLACENCODERSYNTAX" = "default" ] && FLACENCODERSYNTAX=flac
2385 [ "$DOTAG" = "y" ] && NEEDMETAFLAC=y
2386 ;;
2387 spx) [ "$SPEEXENCODERSYNTAX" = "default" ] && SPEEXENCODERSYNTAX=speexenc ;;
2388 mpc) [ "$MPPENCODERSYNTAX" = "default" ] && MPPENCODERSYNTAX=mppenc ;;
2389 *) echo "abcde error: Invalid OUTPUTTYPE defined" >&2
2390 exit 1
2391 ;;
2392 esac
2393 done
2394
2395 # decide which encoder
2396 case "$MP3ENCODERSYNTAX" in
2397 lame)
2398 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$LAMEOPTS}"
2399 MP3ENCODER="$LAME"
2400 ;;
2401 gogo)
2402 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$GOGOOPTS}"
2403 MP3ENCODER="$GOGO"
2404 ;;
2405 bladeenc)
2406 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$BLADEENCOPTS}"
2407 MP3ENCODER="$BLADEENC"
2408 ;;
2409 l3enc)
2410 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$L3ENCOPTS}"
2411 MP3ENCODER="$L3ENC"
2412 ;;
2413 xingmp3enc)
2414 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$XINGMP3ENCOPTS}"
2415 MP3ENCODER="$XINGMP3ENC"
2416 ;;
2417 mp3enc)
2418 MP3ENCODEROPTS="${MP3ENCODEROPTSCLI:-$MP3ENCOPTS}"
2419 MP3ENCODER="$MP3ENC"
2420 ;;
2421 esac
2422 case "$OGGENCODERSYNTAX" in
2423 vorbize)
2424 OGGENCODEROPTS="${OGGENCODEROPTSCLI:-$VORBIZEOPTS}"
2425 OGGENCODER="$VORBIZE"
2426 ;;
2427 oggenc)
2428 OGGENCODEROPTS="${OGGENCODEROPTSCLI:-$OGGENCOPTS}"
2429 OGGENCODER="$OGGENC"
2430 ;;
2431 esac
2432 case "$FLACENCODERSYNTAX" in
2433 flac)
2434 FLACENCODEROPTS="${FLACENCODEROPTSCLI:-$FLACOPTS}"
2435 FLACENCODER="$FLAC"
2436 ## FIXME ## FLAC streams can be encapsulated on a Ogg transport layer
2437 if echo "$FLACENCODEROPTS" | egrep -q -- "(^| )--ogg($| )" ;then
2438 FLACONOGG=y
2439 fi
2440 ;;
2441 esac
2442 case "$SPEEXENCODERSYNTAX" in
2443 speexenc)
2444 SPEEXENCODEROPTS="${SPEEXENCODEROPTSCLI:-$SPEEXENCOPTS}"
2445 SPEEXENCODER="$SPEEXENC"
2446 ;;
2447 esac
2448 case "$MPPENCODERSYNTAX" in
2449 mppenc)
2450 MPPENCODEROPTS="${MPPENCODEROPTSCLI:-$MPPENCOPTS}"
2451 MPPENCODER="$MPPENC"
2452 ;;
2453 esac
2454
2455 # and which tagger
2456
2457 if [ "$ID3TAGV" = "1" ]; then
2458 TAGGER="$ID3"
2459 TAGGEROPTS="$ID3OPTS"
2460 else
2461 TAGGER="$ID3V2"
2462 TAGGEROPTS="$ID3V2OPTS"
2463 fi
2464
2465 # Clean up nice options (either use '-n NICELEVEL or -NICELEVEL')
2466
2467 if [ "$ENCNICE" ]; then
2468 ENCNICE="-n $ENCNICE"
2469 fi
2470 if [ "$READNICE" ]; then
2471 READNICE="-n $READNICE"
2472 fi
2473 if [ "$DISTMP3NICE" ]; then
2474 DISTMP3NICE="-n $DISTMP3NICE"
2475 fi
2476
2477 # Don't check for stuff if it's not needed
2478 if [ "$REMOTEHOSTS" ]; then
2479 NEEDDISTMP3=y
2480 fi
2481 if [ "$DONORMALIZE" = "y" ]; then
2482 NEEDNORMALIZER=y
2483 fi
2484 if [ "$EJECTCD" = "y" ]; then
2485 NEEDEJECT=y
2486 fi
2487 if [ ! "$CDDBAVAIL" = "n" ] && [ "$DOCDDB" = "y" ]; then
2488 NEEDHTTPGET=y
2489 fi
2490 if [ "$CUEFILE" = "y" ]; then
2491 NEEDMKCUE=y
2492 fi
2493
2494 if [ X"$CDSPEEDVALUE" != "X" ]; then
2495 case "$CDROMREADERSYNTAX" in
2496 cdparanoia|debug) CDROMREADEROPTS="$CDPARANOIAOPTS -S $CDSPEEDVALUE" ;;
2497 *) NEEDCDSPEED=y ;;
2498 esac
2499 fi
2500
2501 # Rippers with USEPIPE support
2502 # FIXME # Include here all the rippers we can figure out support pipes
2503 PIPE_cdparanoia="-"
2504
2505 # Encoders with USEPIPE support
2506 # FIXME # Include here all the encoders we can figure out support pipes
2507 PIPE_lame="-"
2508 PIPE_bladeenc="-"
2509 PIPE_oggenc="-"
2510
2511 # Figure out if we can use pipes with the ripper/encoder combination
2512 # exit otherwise
2513 if [ "$USEPIPES" = "y" ]; then
2514 PIPERIPPERSVARCHECK="PIPE_${CDROMREADER}"
2515 case "$OUTPUT" in
2516 mp3)
2517 PIPEENCODERSVARCHECK="PIPE_$MP3ENCODERSYNTAX" ;;
2518 ogg)
2519 PIPEENCODERSVARCHECK="PIPE_$OGGENCODERSYNTAX" ;;
2520 flac)
2521 PIPEENCODERSVARCHECK="PIPE_$FLACENCODERSYTNAX" ;;
2522 spx)
2523 PIPEENCODERSVARCHECK="PIPE_$SPEEXENCODER" ;;
2524 mpc)
2525 PIPEENCODERSVARCHECK="PIPE_$MPPENCODER" ;;
2526 esac
2527 if [ ! -n "${!PIPERIPPERSVARCHECK}" ] ; then
2528 echo "abcde error: no support for pipes with given ripper" >&2
2529 echo "read the USEPIPES file from the source tarball to help" >&2
2530 echo "on a Debian system, read /usr/share/doc/abcde/USEPIPES.gz" >&2
2531 exit 1;
2532 fi
2533 if [ ! -n "${!PIPEENCODERSVARCHECK}" ] ; then
2534 echo "abcde error: no support for pipes with given encoder" >&2
2535 echo "read the USEPIPES file from the source tarball to help" >&2
2536 echo "on a Debian system, read /usr/share/doc/abcde/USEPIPES.gz" >&2
2537 exit 1;
2538 fi
2539 fi
2540
2541
2542 # Make sure a buncha things exist
2543 for X in $CDROMREADER $CDDISCID ${NEEDTAGGER+$TAGGER} $MP3ENCODER \
2544 $OGGENCODER $FLACENCODER $SPEEXENCODER $MPPENCODER \
2545 ${NEEDHTTPGET+$HTTPGET} ${NEEDDISTMP3+$DISTMP3} \
2546 ${NEEDCOMMENTER+$VORBISCOMMENT} ${NEEDMETAFLAC+$METAFLAC} \
2547 ${NEEDNORMALIZER+$NORMALIZER} ${NEEDEJECT+$EJECT} \
2548 ${NEEDDISKTOOL+disktool} ${NEEDCDSPEED+$CDSPEED} \
2549 ${NEEDVORBISGAIN+$VORBISGAIN} ${NEEDMKCUE+$MKCUE}
2550 do
2551 # Cut off the command-line options we just added in
2552 X=$(echo $X | cut -d' ' -f2)
2553 if [ "$(which $X)" = "" ]; then
2554 echo "abcde error: $X is not in your path." >&2
2555 exit 1
2556 elif [ ! -x $(which $X) ]; then
2557 echo "abcde error: $X is not executable." >&2
2558 exit 1
2559 fi
2560 done
2561
2562 CDROMREADER="$CDROMREADER $CDROMREADEROPTS"
2563 CDDBTOOL="$CDDBTOOL $CDDBTOOLOPTS"
2564 HTTPGET="$HTTPGET $HTTPGETOPTS"
2565
2566 # Here it used to say:
2567 # One thousand lines in, we can start doing stuff with things
2568 # Well, right now we are at line 2157 ;)
2569
2570 # Export needed things so they can be read in this subshell
2571 export CDDBTOOL ABCDETEMPDIR TRACKQUEUE LOWDISK EJECTCD EJECT EJECTOPTS
2572 export CDROM CDDBDATA REMOTEHOSTS MAXPROCS HTTPGET MD5SUM
2573
2574 # User-definable function to set some things. Use it for
2575 # - closing the CD tray with eject -t
2576 # - set the CD speed value with eject -x
2577 vecho -n "Executing customizable pre-read function... "
2578
2579 pre_read # Execute the user-defined pre-read funtion. Close the CD with it.
2580
2581 vecho "done."
2582
2583 do_discid # Get ABCDETEMPDIR created and status file initialized
2584
2585 if [ "$DOCDDB" = "y" ]; then
2586 if [ $CDDBUSELOCAL = "y" ]; then
2587 do_localcddb
2588 fi
2589 if checkstatus cddb-choice > /dev/null; then
2590 :
2591 else
2592 if [ ! "$CDDBLOCALSUCCESS" = "y" ] ; then
2593 do_cddbstat
2594 do_cddbquery
2595 do_cddbread
2596 fi
2597 fi
2598 do_cddbedit
2599
2600 eval $($CDDBTOOL parse "$CDDBDATA")
2601 fi
2602
2603 # Before reading tracks, we set the speed of the device
2604
2605 if [ X"$CDSPEEDVALUE" != "X" ]; then
2606 case "$CDROMREADERSYNTAX" in
2607 cdparanoia|debug) : ;;
2608 *) do_cdspeed ;;
2609 esac
2610 fi
2611
2612 # Define the first and last track, since we might need them later in several places
2613 FIRSTTRACK=$( get_first $TRACKQUEUE )
2614 LASTTRACK=$( get_last $TRACKQUEUE )
2615
2616 if [ -f "$ABCDETEMPDIR/status" ] && [ X"$ERASEENCODEDSTATUS" = "Xy" ]; then
2617 mv "$ABCDETEMPDIR/status" "$ABCDETEMPDIR/status.old"
2618 grep -v ^encodetracklocation- < "$ABCDETEMPDIR/status.old" \
2619 | grep -v ^encode-output > "$ABCDETEMPDIR/status"
2620 fi
2621
2622 # Create playlist if needed (backgroundable) and start reading in tracks
2623
2624 (
2625
2626 if [ ! "$ONETRACK" = "y" ]; then
2627 if [ "$DOPLAYLIST" = "y" ]; then
2628 echo Creating playlist... >&2
2629 do_playlist
2630 fi
2631 fi
2632
2633 # For the lowdisk option, only one program is running at once so the encoder
2634 # can be unsilenced right away.
2635 if [ "$LOWDISK" = "y" ] || [ "$ONETRACK" = "y" ]; then
2636 echo "encode-output=loud" >> "$ABCDETEMPDIR/status"
2637 fi
2638
2639 if [ "$ONETRACK" = "y" ]; then
2640 TRACKS="$FIRSTTRACK"
2641 if checkstatus readtrack-$FIRSTTRACK; then :; else
2642 do_cdread onetrack $FIRSTTRACK $LASTTRACK
2643 fi
2644 else
2645 for UTRACKNUM in $TRACKQUEUE
2646 do
2647 if [ "$DOREAD" = "y" ]; then
2648 if [ "$USEPIPES" = "y" ]; then
2649 if checkstatus readencodetrack-$UTRACKNUM; then :; else
2650 # Read, pipe, shut up!
2651 do_cdread $UTRACKNUM | do_encode $UTRACKNUM %local0% > /dev/null 2>&1
2652 fi
2653 else
2654 if checkstatus readtrack-$UTRACKNUM; then :; else
2655 do_cdread $UTRACKNUM
2656 fi
2657 if [ "$?" != "0" ]; then
2658 # CD read failed - don't give the goahead to
2659 # the encoder
2660 echo NO
2661 exit
2662 fi
2663 fi
2664 fi
2665 if [ "$BATCH" = "y" ]; then
2666 :
2667 else
2668 echo NEXTTRACK # Get the encoder machine churning again
2669 if [ "$DOREAD" = "y" ]; then
2670 if [ "$LOWDISK" = "y" ] && [ "$DOENCODE" = "y" ]; then
2671 until checkstatus encodetrack-$UTRACKNUM
2672 do
2673 if checkerrors encodetrack-$UTRACKNUM; then
2674 break
2675 fi
2676 sleep 2
2677 done
2678 fi
2679 fi
2680 fi
2681 done
2682 fi
2683
2684 # Now that we're done the encoding can be loud again -
2685 # if we're not using SMP.
2686 if [ "$MAXPROCS" = "1" ]; then
2687 echo "encode-output=loud" >> "$ABCDETEMPDIR/status"
2688 fi
2689
2690 # All tracks read, start encoding.
2691 if [ "$BATCH" = "y" ] || [ "$ONETRACK" = "y" ]; then
2692 echo NEXTTRACK
2693 fi
2694
2695 # We are now finished with the cdrom - it can be safely ejected. Note that
2696 # abcde will not have completed yet.
2697 if [ "$EJECTCD" = "y" ] && [ -x $(which $EJECT) ]; then
2698 # We check if the disk we are processing is actually the disk inside the
2699 # CD tray. If not, we do not eject the CD, since it might be so that the
2700 # user ejected it manually.
2701 #CURRENTTRACKINFO=$($CDDISCID $CDROM)
2702 #if if [ "$?" != "1" ] && [ "$CURRENTTRACKINFO" = "$TRACKINFO" ] ; then
2703 # More FreeBSD bits.
2704 if [ X"$(uname)" = X"FreeBSD" ] ; then
2705 # FreeBSD eject uses the EJECT environment variable to name the CDROM
2706 # but in this script EJECT is in the envionment and names the program
2707 eject=$EJECT
2708 unset EJECT
2709 # The FreeBSD eject needs "adc0" not "/dev/adc0c"
2710 cd="$(echo $CDROM | sed -e 's=.*/==;s=[a-h]$==;')"
2711 $eject $EJECTOPTS $cd
2712 elif [ X"$(uname)" = X"Darwin" ] ; then
2713 disktool -e ${CDROM#/dev/} 0
2714 else
2715 $EJECT $EJECTOPTS $CDROM
2716 fi
2717 #fi
2718 fi
2719
2720 ) | (
2721
2722 ## Do we need to pre-process
2723 #if [ x"$PREPROCESS" = "x" ] ; then
2724 # cat
2725 #else
2726 # for PRETRACKNUM in $TRACKQUEUE
2727 # do
2728 # read GOAHEAD
2729 # if [ "$GOAHEAD" = "NO" ]; then break; fi
2730 # PREPROCEED=
2731 # until [ $PREPROCEED ]
2732 # do
2733 # if checkstatus readtrack-$PRETRACKNUM; then PREPROCEED=y; break; fi
2734 # # all locations are working, wait and try again later
2735 # if [ ! $PREPROCEED ]; then sleep 3; fi
2736 # done
2737 # ( do_preprocess $PRETRACKNUM
2738 # echo "NEXTTRACK"
2739 # ) &
2740 # done
2741 #fi
2742 #
2743 #) | (
2744
2745 # In batch mode, we want all tracks to be read first.
2746 if [ "$BATCH" = "y" ]; then
2747 read GOAHEAD # For blocking - will contain either "NO" or "NEXTTRACK"
2748 if [ "$GOAHEAD" = "NO" ]; then break; fi
2749 for LASTTRACK in $TRACKQUEUE; do :; done
2750 if checkstatus readtrack-$LASTTRACK; then
2751 if [ "$DONORMALIZE" = "y" ]; then
2752 if checkstatus normalizetrack-$LASTTRACK; then :; else do_batch_normalize; fi
2753 if checkerrors batch-normalize; then exit; fi
2754 fi
2755 if [ "$DOENCODE" = "y" ]; then
2756 if checkstatus encodetrack-$LASTTRACK; then :; else do_batch_encode; fi
2757 if checkerrors batch-encode; then exit; fi
2758 fi
2759 fi
2760 fi
2761
2762 # If we are using ONETRACK, we can proceed with the normal encoding using just the $FIRSTTRACK as TRACKQUEUE
2763 if [ "$ONETRACK" = "y" ] ; then
2764 TRACKQUEUE="$FIRSTTRACK"
2765 TRACKS="$FIRSTTRACK"
2766 fi
2767
2768 # Do the encoding, including parallelization of remote encoding
2769 # Figure out where each track is going to be encoded
2770 ENCODELOCATIONS="$(echo $REMOTEHOSTS | tr , ' ')"
2771 if [ "$MAXPROCS" != "0" ]; then
2772 for NUM in $(f_seq_row 1 "$MAXPROCS")
2773 do
2774 ENCODELOCATIONS="$ENCODELOCATIONS %local$NUM%"
2775 done
2776 fi
2777 # Strip whitespace
2778 ENCODELOCATIONS=$(echo $ENCODELOCATIONS)
2779 for UTRACKNUM in $TRACKQUEUE
2780 do
2781 # Wait for our cue
2782 read GOAHEAD # For blocking - will contain either "NO" or "NEXTTRACK"
2783 if [ "$GOAHEAD" = "NO" ]; then break; fi
2784 # find out where this track is to be encoded
2785 if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
2786 # Make sure we have a place to encode this, if not, exit stage right
2787 if [ -z "$ENCODELOCATIONS" ]; then
2788 continue
2789 fi
2790 PROCEED=
2791 until [ $PROCEED ]
2792 do
2793 for LOCATION in $ENCODELOCATIONS
2794 do
2795 PREVIOUSTRACK="$(checkstatus encodetracklocation-$LOCATION)"
2796 # check first if a track has ever been assigned to this location
2797 if [ -z "$PREVIOUSTRACK" ]; then PROCEED=y; break; fi
2798 # If it errored out, rebuild $ENCODELOCATIONS without this location in it
2799 if checkerrors encodetrack-$PREVIOUSTRACK; then
2800 for TEMPLOCATION in $ENCODELOCATIONS
2801 do
2802 if [ "$TEMPLOCATION" != "$LOCATION" ]; then
2803 TEMPENCODELOCATIONS="$TEMPENCODELOCATIONS $TEMPLOCATION"
2804 fi
2805 done
2806 ENCODELOCATIONS=$(echo $TEMPENCODELOCATIONS)
2807 ABORT=y
2808 PROCEED=y
2809 break
2810 fi
2811 # We're still here, this location must have been previously assigned,
2812 # and last completed without error - check if it's done with the
2813 # previous track yet
2814 if checkstatus encodetrack-$PREVIOUSTRACK; then PROCEED=y; break; fi
2815 done
2816 # all locations are working, wait and try again later
2817 if [ ! $PROCEED ]; then sleep 3; fi
2818 done
2819 # Record the location we're about to encode the next track at
2820 echo "encodetracklocation-$LOCATION=$UTRACKNUM" >> "$ABCDETEMPDIR/status"
2821 fi
2822 # Don't proceed with the rest of the loop if we can't encode
2823 if [ "$ABORT" ]; then continue; fi
2824 # Set TRACKNUM, TRACKNAME
2825 if [ -e "$CDDBDATA" ]; then
2826 if [ "$ONETRACK" = "y" ]; then
2827 TRACKNAME="$DALBUM"
2828 TRACKNUM="$FIRSTTRACK"
2829 splitvarious
2830 else
2831 # TRACKNUM=$(printf %0.${TRACKNUMPADDING}d $(expr ${UTRACKNUM} + 0))
2832 TRACKNUM=$UTRACKNUM
2833 CDDBTRACKNUM=$(expr $UTRACKNUM - 1)
2834 TRACKNAME="$(grep ^TTITLE$CDDBTRACKNUM= "$CDDBDATA" | cut -f2- -d= | tr -d \[:cntrl:\] | sed 's/\ \+$//')"
2835 splitvarious
2836 fi
2837 fi
2838 # You can't encode a file which needs to be normalized before finishing
2839 # You can't tag a file before it's finished encoding -
2840 # thus all of this is backgrounded together
2841 (
2842 if [ "$DONORMALIZE" = "y" ]; then
2843 if checkstatus readtrack-$UTRACKNUM; then
2844 if checkstatus normalizetrack-$UTRACKNUM; then :; else do_normalize $UTRACKNUM; fi
2845 fi
2846 fi
2847 if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
2848 if checkstatus readtrack-$UTRACKNUM; then
2849 #if checkstatus encodetrack-$UTRACKNUM; then :; else do_encode $UTRACKNUM $LOCATION; fi
2850 if [ "$DONORMALIZE" = "y" ]; then
2851 if checkstatus normalizetrack-$UTRACKNUM; then
2852 if checkstatus encodetrack-$UTRACKNUM; then :; else do_encode $UTRACKNUM $LOCATION $OUTPUT; fi
2853 fi
2854 else
2855 if checkstatus encodetrack-$UTRACKNUM; then :; else do_encode $UTRACKNUM $LOCATION $OUTPUT; fi
2856 fi
2857 fi
2858 fi
2859 if [ "$DOTAG" = "y" ]; then
2860 if checkstatus encodetrack-$UTRACKNUM; then
2861 if checkstatus tagtrack-$UTRACKNUM; then :; else do_tag $UTRACKNUM; fi
2862 fi
2863 fi
2864 if [ "$DOMOVE" = "y" ]; then
2865 if checkstatus tagtrack-$UTRACKNUM; then
2866 if checkstatus movetrack-$UTRACKNUM; then :; else do_move $UTRACKNUM; fi
2867 fi
2868 fi
2869 ) &
2870 done
2871
2872 # Lets move the cue file
2873 if checkstatus cuefile >/dev/null ; then
2874 do_movecue
2875 fi
2876
2877 # Go through it again and make sure there's no distmp3 stragglers, otherwise
2878 # we'll delete the files they're working on
2879 ## FIXME ## Check also for files which are encoded using PIPEs.
2880 if [ "$DOENCODE" = "y" -a "$USEPIPES" != "y" ]; then
2881 PROCEED=
2882 until [ $PROCEED ]
2883 do
2884 PROCEED=y
2885 for LOCATION in $ENCODELOCATIONS
2886 do
2887 CHECKTRACK="$(checkstatus encodetracklocation-$LOCATION)"
2888 # "How can he give us a status update, if he's DEAD?"
2889 if checkstatus encodetrack-$CHECKTRACK; then
2890 continue
2891 fi
2892 # Nothing to see here please go quietly back to your homes
2893 if [ -z "$CHECKTRACK" ]; then continue; fi
2894 # You're still here? Maybe there is something...
2895 if checkstatus encodetrack-$CHECKTRACK; then :; else PROCEED= ; break; fi
2896 done
2897 # hold up
2898 if [ ! $PROCEED ]; then sleep 5; fi
2899 done
2900 fi
2901 # If the above didn't catch the stragglers, this will
2902 wait
2903 # Check to see if run_command logged any errors
2904 if [ -f "$ABCDETEMPDIR/errors" ]; then
2905 echo "The following commands failed to run:"
2906 cat "$ABCDETEMPDIR/errors"
2907 # Don't clean up
2908 DOCLEAN=n
2909 fi
2910 if [ "$KEEPWAVS" = "y" ];then
2911 # Don't clean up
2912 DOCLEAN=n
2913 fi
2914 if [ "$DOCLEAN" = "y" ]; then
2915 # Wipe all the evidence
2916 # Gimme gimme gimme some more time!
2917 sleep 5
2918 rm -rf "$ABCDETEMPDIR"
2919 echo "Finished."
2920 else
2921 echo "Finished. Not cleaning $ABCDETEMPDIR."
2922 fi
2923 )
2924 exit 0
2925
2926 # b:is_bash
2927 # vim:tabstop=4